SystemOrganization addCategory: #'Pier-Tests-Core'!
SystemOrganization addCategory: #'Pier-Tests-Kernel'!
SystemOrganization addCategory: #'Pier-Tests-Structure'!
SystemOrganization addCategory: #'Pier-Tests-Document'!
SystemOrganization addCategory: #'Pier-Tests-Command'!
SystemOrganization addCategory: #'Pier-Tests-Utilities'!

TestCase subclass: #PRExtensionsTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Tests-Core'!

TestCase subclass: #PRObjectTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Tests-Core'!

PRObjectTest subclass: #PRCommandTest
	instanceVariableNames: 'kernel structure context command'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Tests-Command'!

PRCommandTest subclass: #PRAddCommandTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Tests-Command'!

!PRAddCommandTest class methodsFor: 'testing' stamp: 'lr 12/5/2005 20:49'!
isAbstract
	^ false! !

!PRAddCommandTest methodsFor: 'private' stamp: 'lr 12/5/2005 20:49'!
actualClass
	^ PRAddCommand! !

!PRAddCommandTest methodsFor: 'testing' stamp: 'lr 12/19/2005 16:43'!
testAddChild
	| child |
	self 
		shouldnt: [ self command execute ]
		raise: PRStructureError.
	self assert: (self structure childrenDecoration 
		includes: self command title).

	child := self structure childrenDecoration 
		at: self command title.
	self assert: child title = self command title.
	self assert: child species = self command type.! !

!PRAddCommandTest methodsFor: 'testing' stamp: 'lr 12/19/2005 16:43'!
testAddConflict
	self 
		shouldnt: [ self command execute ]
		raise: PRConflictingTitle.
	self
		should: [ self command execute ]
		raise: PRConflictingTitle.
! !

!PRAddCommandTest methodsFor: 'testing-utilties' stamp: 'lr 12/19/2005 16:15'!
testUniqueTitle
	20 timesRepeat: [
		self 
			shouldnt: [
				self structure addChild: (PRPage new 
					title: (self command
						uniqueTitle: 'foo'
						in: self structure);
					yourself) ]
			raise: Error ].
	#( 'foo' 'foo 2' 'foo 9' 'foo 10' 'foo 11' 'foo 20' ) do: [ :each |
		self assert: (self structure childrenDecoration includes: each) ].! !

!PRCommandTest class methodsFor: 'testing' stamp: 'lr 12/5/2005 20:49'!
isAbstract
	^ true! !

!PRCommandTest methodsFor: 'private' stamp: 'lr 12/5/2005 20:49'!
actualClass
	^ PRCommand! !

!PRCommandTest methodsFor: 'private' stamp: 'lr 12/5/2005 20:46'!
actualInstance
	^ self actualClass context: self context.! !

!PRCommandTest methodsFor: 'accessing' stamp: 'lr 12/5/2005 20:46'!
command
	^ command ifNil: [ command := self actualInstance ].! !

!PRCommandTest methodsFor: 'accessing' stamp: 'lr 12/5/2005 18:07'!
context
	^ context ifNil: [ context := self contextInstance ].! !

!PRCommandTest methodsFor: 'private' stamp: 'lr 12/5/2005 18:09'!
contextInstance
	^ PRContext kernel: self kernel structure: self structure.! !

!PRCommandTest methodsFor: 'accessing' stamp: 'lr 12/5/2005 18:07'!
instance
	^ self command.! !

!PRCommandTest methodsFor: 'accessing' stamp: 'lr 12/5/2005 18:07'!
kernel
	^ kernel ifNil: [ kernel := self kernelInstance ].! !

!PRCommandTest methodsFor: 'private' stamp: 'lr 12/5/2005 20:25'!
kernelInstance
	^ PRKernel new
		root: (PRPage new
			title: 'root';
			addChild: self structure;
			addChild: (PRPage new
				title: 'folder';
				yourself);
			yourself);
		yourself.! !

!PRCommandTest methodsFor: 'accessing' stamp: 'lr 12/5/2005 18:07'!
structure
	^ structure ifNil: [ structure := self structureInstance ].! !

!PRCommandTest methodsFor: 'private' stamp: 'lr 12/5/2005 18:10'!
structureInstance
	^ PRPage new 
		title: 'command';
		yourself.! !

!PRCommandTest methodsFor: 'testing-accessing' stamp: 'lr 12/5/2005 18:02'!
testAnswer
	self assert: self command answer isNil.
	self command answer: self context.
	self assert: self command answer = self context.! !

!PRCommandTest methodsFor: 'testing-accessing' stamp: 'lr 12/5/2005 18:02'!
testContext
	self assert: self command context notNil.
	self command context: self context.
	self assert: self command context = self context.! !

!PRCommandTest methodsFor: 'testing-testing' stamp: 'lr 12/5/2005 18:05'!
testIsLogged
	self assert: self command isLogged.! !

!PRCommandTest methodsFor: 'testing-testing' stamp: 'lr 12/5/2005 18:05'!
testIsView
	self deny: self command isView.! !

!PRCommandTest methodsFor: 'testing-accessing' stamp: 'lr 12/5/2005 18:03'!
testKernel
	self assert: self command kernel = self kernel.! !

!PRCommandTest methodsFor: 'testing-accessing' stamp: 'lr 12/5/2005 18:03'!
testRoot
	self assert: self command root = self kernel root.! !

!PRCommandTest methodsFor: 'testing-accessing' stamp: 'lr 12/5/2005 18:34'!
testStructure
	self assert: self command structure = self structure.! !

!PRCommandTest methodsFor: 'testing-accessing' stamp: 'lr 12/5/2005 18:04'!
testTimestamp
	| stamp |
	self assert: self command timestamp isNil.
	self command timestamp: (stamp := TimeStamp now).
	self assert: self command timestamp = stamp.! !

!PRCommandTest methodsFor: 'testing-utilities' stamp: 'lr 12/19/2005 16:11'!
testUniqueAdding
	20 timesRepeat: [
		self 
			shouldnt: [
				self structure addChild: (PRPage new 
					title: (self command
						uniqueTitle: 'foo'
						in: self structure);
					yourself) ]
			raise: Error ]! !

!PRCommandTest methodsFor: 'testing-validating' stamp: 'lr 12/5/2005 17:55'!
testValidateChild
	self 
		should: [ 
			self command 
				validateChild: (PRPage new
					title: 'folder';
					yourself)
				in: self context root ] 
		raise: PRConflictingTitle.
	self 
		shouldnt: [ 
			self command 
				validateChild: (PRPage new
					title: 'zork';
					yourself) 
				in: self context root ] 
		raise: PRConflictingTitle.
	self 
		shouldnt: [ 
			self command 
				validateChild: (self context root childrenDecoration 
					at: 'folder') 
				in: self context root ] 
		raise: PRConflictingTitle.
	! !

!PRCommandTest methodsFor: 'testing-validating' stamp: 'lr 12/5/2005 17:56'!
testValidateChildTitled
	self 
		should: [ 
			self command 
				validateChild: PRPage new
				titled: 'folder'
				in: self context root ] 
		raise: PRConflictingTitle.
	self 
		shouldnt: [ 
			self command 
				validateChild: PRPage new
				titled: 'zork'
				in: self context root ] 
		raise: PRConflictingTitle.
	self 
		shouldnt: [ 
			self command 
				validateChild: (self context root childrenDecoration 
					at: 'folder')
				titled: 'zork'
				in: self context root ] 
		raise: PRConflictingTitle.
	! !

!PRCommandTest methodsFor: 'testing-validating' stamp: 'lr 12/5/2005 17:42'!
testValidateNesting
	self 
		shouldnt: [ self command validateNestingOf: self context root in: PRPage new ] 
		raise: PRInvalidNesting.
	self 
		shouldnt: [ self command validateNestingOf: PRPage new in: self context root ] 
		raise: PRInvalidNesting.! !

!PRCommandTest methodsFor: 'testing-validating' stamp: 'lr 12/5/2005 17:42'!
testValidateTitle
	self 
		shouldnt: [ self command validateTitle: 'zork' of: PRPage new in: self context root ] 
		raise: PRConflictingTitle.
	self 
		should: [ self command validateTitle: 'folder' of: PRPage new in: self context root ] 
		raise: PRConflictingTitle.
	self 
		shouldnt: [ self command validateTitle: 'zork' of: (self context root childrenDecoration at: 'folder') in: self context root ] 
		raise: PRConflictingTitle.
	self 
		shouldnt: [ self command validateTitle: 'folder' of: (self context root childrenDecoration at: 'folder') in: self context root ] 
		raise: PRConflictingTitle.! !

PRCommandTest subclass: #PRCopyCommandTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Tests-Command'!

!PRCopyCommandTest class methodsFor: 'testing' stamp: 'lr 12/5/2005 20:49'!
isAbstract
	^ false! !

!PRCopyCommandTest methodsFor: 'private' stamp: 'lr 12/5/2005 20:49'!
actualClass
	^ PRCopyCommand! !

!PRCopyCommandTest methodsFor: 'testing' stamp: 'lr 12/19/2005 16:49'!
testCopyConflict
	self command title: 'folder'.
	self 
		should: [ self command execute ]
		raise: PRStructureError.
! !

!PRCopyCommandTest methodsFor: 'testing' stamp: 'lr 12/19/2005 16:58'!
testCopyInitialized
	self assert: self command title = (self structure title , ' copy').
	self assert: self command target = self structure parent.
! !

!PRCopyCommandTest methodsFor: 'testing' stamp: 'lr 12/19/2005 16:53'!
testCopyIntoChild
	self command 
		title: 'foo';
		target: self structure.
	self 
		shouldnt: [ self command execute ]
		raise: PRStructureError.
	self assert: (self structure childrenDecoration
		includes: 'foo').
	self assert: (self structure childrenDecoration
		at: 'foo') = self command answer structure.

! !

!PRCopyCommandTest methodsFor: 'testing' stamp: 'lr 12/19/2005 16:54'!
testCopyIntoRoot
	self command 
		title: 'foo';
		target: self command root.
	self 
		shouldnt: [ self command execute ]
		raise: PRStructureError.
	self assert: (self command root childrenDecoration
		includes: 'foo').
	self assert: (self command root childrenDecoration
		at: 'foo') = self command answer structure.

! !

!PRCopyCommandTest methodsFor: 'testing' stamp: 'lr 12/19/2005 16:57'!
testCopySimple
	self command title: 'foo'.
	self 
		shouldnt: [ self command execute ]
		raise: PRStructureError.
	self assert: (self structure parent childrenDecoration
		includes: 'foo').
	self assert: (self structure parent childrenDecoration
		at: 'foo') = self command answer structure.

! !

!PRCopyCommandTest methodsFor: 'testing' stamp: 'lr 12/19/2005 16:49'!
testCopyTarget
	self command title: 'foo'.
	self 
		shouldnt: [ self command execute ]
		raise: PRStructureError.
	self assert: (self structure parent childrenDecoration
		includes: 'foo').
	self assert: (self structure parent childrenDecoration
		at: 'foo') = self command answer structure.

! !

PRCommandTest subclass: #PREditCommandTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Tests-Command'!

!PREditCommandTest class methodsFor: 'testing' stamp: 'lr 12/5/2005 20:49'!
isAbstract
	^ true! !

!PREditCommandTest methodsFor: 'private' stamp: 'lr 12/5/2005 20:49'!
actualClass
	^ PREditCommand! !

!PREditCommandTest methodsFor: 'testing-title' stamp: 'lr 12/19/2005 15:24'!
testTitleConflict
	self command title: 'folder'.
	self 
		should: [ self command execute ]
		raise: PRConflictingTitle.! !

!PREditCommandTest methodsFor: 'testing-title' stamp: 'lr 12/19/2005 15:26'!
testTitleInitialized
	self assert: self command title = self structure title.! !

!PREditCommandTest methodsFor: 'testing-title' stamp: 'lr 12/19/2005 15:26'!
testTitleRenamed
	self command title: 'foobar'.
	self 
		shouldnt: [ self command execute ]
		raise: PRConflictingTitle.
	self assert: self structure title = 'foobar'.! !

!PREditCommandTest methodsFor: 'testing-title' stamp: 'lr 12/19/2005 15:26'!
testTitleUnchanged
	self 
		shouldnt: [ self command execute ]
		raise: PRConflictingTitle.
	self assert: self structure title = self command title.! !

PREditCommandTest subclass: #PREditFileCommandTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Tests-Command'!

!PREditFileCommandTest class methodsFor: 'testing' stamp: 'lr 12/5/2005 20:49'!
isAbstract
	^ false! !

!PREditFileCommandTest methodsFor: 'private' stamp: 'lr 12/5/2005 20:49'!
actualClass
	^ PREditFileCommand! !

!PREditFileCommandTest methodsFor: 'private' stamp: 'lr 12/5/2005 21:56'!
structureInstance
	^ PRFile new 
		title: 'command';
		yourself.! !

!PREditFileCommandTest methodsFor: 'testing-file' stamp: 'lr 12/19/2005 15:48'!
testFileChanged
	| file |
	file := MAFileModel new
		contents: 'foobar';
		filename: 'test.txt';
		mimetype: 'text/plain';
		yourself.
	self command file: file. 
	self 
		shouldnt: [ self command execute ]
		raise: PRStructureError.
	self assert: self structure file = file.! !

!PREditFileCommandTest methodsFor: 'testing-file' stamp: 'lr 12/19/2005 15:43'!
testFileInitialized
	self assert: self command file = self structure file.! !

!PREditFileCommandTest methodsFor: 'testing-file' stamp: 'lr 12/19/2005 15:50'!
testFileUnchanged
	| file |
	file := self structure file.
	self 
		shouldnt: [ self command execute ]
		raise: PRStructureError.
	self assert: self structure file = file.! !

PREditCommandTest subclass: #PREditPageCommandTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Tests-Command'!

!PREditPageCommandTest class methodsFor: 'testing' stamp: 'lr 12/5/2005 20:49'!
isAbstract
	^ false! !

!PREditPageCommandTest methodsFor: 'private' stamp: 'lr 12/5/2005 20:49'!
actualClass
	^ PREditPageCommand! !

!PREditPageCommandTest methodsFor: 'private' stamp: 'lr 12/5/2005 21:56'!
structureInstance
	^ PRPage new 
		title: 'command';
		yourself.! !

!PREditPageCommandTest methodsFor: 'testing-contents' stamp: 'lr 12/19/2005 15:49'!
testContentsChanged
	| contents |
	contents := '!!foo
bar'.
	self command contents: contents.
	self 
		shouldnt: [ self command execute ]
		raise: PRStructureError.
	self assert: self structure contents = contents.! !

!PREditPageCommandTest methodsFor: 'testing-contents' stamp: 'lr 12/19/2005 15:35'!
testContentsInitialized
	self assert: self command title = self structure title.! !

!PREditPageCommandTest methodsFor: 'testing-contents' stamp: 'lr 12/19/2005 15:50'!
testContentsUnchanged
	| contents |
	contents := self structure contents.
	self 
		shouldnt: [ self command execute ]
		raise: PRStructureError.
	self assert: self structure contents = contents.! !

PRCommandTest subclass: #PRMoveCommandTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Tests-Command'!

!PRMoveCommandTest class methodsFor: 'testing' stamp: 'lr 12/5/2005 20:49'!
isAbstract
	^ false! !

!PRMoveCommandTest methodsFor: 'private' stamp: 'lr 12/5/2005 20:49'!
actualClass
	^ PRMoveCommand! !

PRCommandTest subclass: #PRRemoveCommandTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Tests-Command'!

!PRRemoveCommandTest class methodsFor: 'testing' stamp: 'lr 12/5/2005 20:49'!
isAbstract
	^ false! !

!PRRemoveCommandTest methodsFor: 'private' stamp: 'lr 12/5/2005 20:49'!
actualClass
	^ PRRemoveCommand! !

PRCommandTest subclass: #PRViewCommandTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Tests-Command'!

!PRViewCommandTest class methodsFor: 'testing' stamp: 'lr 12/5/2005 20:49'!
isAbstract
	^ false! !

!PRViewCommandTest methodsFor: 'private' stamp: 'lr 12/5/2005 20:49'!
actualClass
	^ PRViewCommand! !

!PRViewCommandTest methodsFor: 'testing-testing' stamp: 'lr 12/5/2005 18:05'!
testIsLogged
	self deny: self command isLogged.! !

!PRViewCommandTest methodsFor: 'testing-testing' stamp: 'lr 12/5/2005 18:05'!
testIsView
	self assert: self command isView.! !

PRObjectTest subclass: #PRContextTest
	instanceVariableNames: 'context'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Tests-Kernel'!

!PRContextTest class methodsFor: 'testing' stamp: 'lr 12/5/2005 20:49'!
isAbstract
	^ false! !

!PRContextTest methodsFor: 'private' stamp: 'lr 12/5/2005 20:49'!
actualClass
	^ PRContext! !

!PRContextTest methodsFor: 'accessing' stamp: 'lr 10/26/2005 07:33'!
context
	^ context ifNil: [ context := self contextInstance ].! !

!PRContextTest methodsFor: 'accessing' stamp: 'lr 10/26/2005 07:33'!
instance
	^ self context.! !

!PRContextTest methodsFor: 'testing-navigation' stamp: 'lr 10/26/2005 07:38'!
testGotoCommand! !

!PRContextTest methodsFor: 'testing-navigation' stamp: 'lr 10/26/2005 08:10'!
testGotoStructure
	| current currentStructure currentCommand next nextStructure |
	currentStructure := self context structure.
	currentCommand := self context command.
	current := self context.

	nextStructure := self context structure childrenDecoration at: 'folder'.
	next := self context structure: nextStructure.

	self deny: current = next.
	
	self assert: current structure = currentStructure.
	self assert: current command = currentCommand.

	self assert: next structure = nextStructure.
	self assert: next command isView.! !

!PRContextTest methodsFor: 'testing-navigation' stamp: 'lr 10/26/2005 07:38'!
testGotoStructureCommand! !

!PRContextTest methodsFor: 'testing' stamp: 'lr 10/26/2005 07:37'!
testInitialState
	self assert: self context structure = self context kernel root.
	self assert: self context command isView.! !

PRObjectTest subclass: #PRDecoratedTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Tests-Structure'!

!PRDecoratedTest class methodsFor: 'testing' stamp: 'lr 12/5/2005 20:49'!
isAbstract
	^ true! !

!PRDecoratedTest methodsFor: 'private' stamp: 'lr 12/5/2005 20:49'!
actualClass
	^ PRDecorated! !

!PRDecoratedTest methodsFor: 'accessing' stamp: 'lr 11/17/2005 15:43'!
decorationWithPriority: anInteger
	^ PRMockDecoration new
		priority: anInteger;
		yourself.! !

!PRDecoratedTest methodsFor: 'testing-adding' stamp: 'lr 12/20/2005 10:01'!
testAddDecoration
	| mock1 mock2 |
	mock1 := self decorationWithPriority: 10.
	mock2 := self decorationWithPriority: -5.

	self assert: (self instance addDecoration: mock1) = mock1.
	self assert: self instance = mock1 decorated.
	self assert: self instance decorations size = 1.
	self assert: self instance decorations first = mock1.
	
	self assert: (self instance addDecoration: mock2) = mock2.
	self assert: self instance = mock2 decorated.
	self assert: self instance decorations size = 2.
	self assert: self instance decorations first = mock2.
	self assert: self instance decorations second = mock1.

	self should: [ self instance addDecoration: mock1 ] raise: Error.
	self should: [ self instance addDecoration: mock2 ] raise: Error.
	self assert: self instance decorations size = 2.
	self assert: self instance decorations first = mock2.
	self assert: self instance decorations second = mock1.! !

!PRDecoratedTest methodsFor: 'testing-adding' stamp: 'lr 12/20/2005 10:02'!
testAddDecorationIfPresent
	| mock1 mock2 |
	mock1 := self decorationWithPriority: 10.
	mock2 := self decorationWithPriority: -5.

	self assert: (self instance 
		addDecoration: mock1
		ifPresent: [ :value | self assert: false ]) = mock1.
	self assert: self instance = mock1 decorated.
	self assert: self instance decorations size = 1.
	self assert: self instance decorations first = mock1.
	
	self assert: (self instance 
		addDecoration: mock2 
		ifPresent: [ :value | self assert: false ]) = mock2.
	self assert: self instance = mock2 decorated.
	self assert: self instance decorations size = 2.
	self assert: self instance decorations first = mock2.
	self assert: self instance decorations second = mock1.

	self assert: (self instance 
		addDecoration: mock1 
		ifPresent: [ :value | nil ]) isNil.
	self assert: (self instance 
		addDecoration: mock2 
		ifPresent: [ :value | nil ]) isNil.
	self assert: self instance decorations size = 2.
	self assert: self instance decorations first = mock2.
	self assert: self instance decorations second = mock1.! !

!PRDecoratedTest methodsFor: 'testing-copying' stamp: 'lr 12/20/2005 10:03'!
testCopyDecorations
	| decoration copiedInstance copiedDecoration |
	decoration := self instance addDecoration: (self decorationWithPriority: 10).
	copiedInstance := self instance copy.
	copiedDecoration := copiedInstance decorations first.

	self deny: self instance = copiedInstance.
	self deny: decoration = copiedDecoration.

	self assert: self instance decorations size = 1.
	self assert: self instance decorations first = decoration.
	self assert: self instance = decoration decorated.

	self assert: copiedInstance decorations size = 1.
	self assert: copiedInstance decorations first = copiedDecoration.
	self assert: copiedInstance = copiedDecoration decorated.! !

!PRDecoratedTest methodsFor: 'testing-querying' stamp: 'lr 11/17/2005 15:43'!
testDecorationOfClass
	| mock |
	self should: [ self instance decorationOfClass: PRMockDecoration ] raise: Error.
	self instance addDecoration: (mock := self decorationWithPriority: 1).
	self assert: (self instance decorationOfClass: PRMockDecoration) = mock.! !

!PRDecoratedTest methodsFor: 'testing-querying' stamp: 'lr 11/17/2005 15:43'!
testDecorationOfClassIfAbsent
	| mock |
	self assert: (self instance decorationOfClass: PRMockDecoration ifAbsent: [ nil ]) isNil.
	self instance addDecoration: (mock := self decorationWithPriority: 1).
	self assert: (self instance decorationOfClass: PRMockDecoration) = mock.! !

!PRDecoratedTest methodsFor: 'testing-enumerating' stamp: 'lr 10/20/2005 16:45'!
testDecorationsDo
	| elements |
	elements := OrderedCollection new
		add: (self instance 
			addDecoration: (self decorationWithPriority: -5));
		add: (self instance
			addDecoration: (self decorationWithPriority: 10));
		yourself.
	self instance decorationsDo: [ :each |
		self assert: each = elements removeFirst.
		self deny: each = self instance ].
	self assert: elements isEmpty.! !

!PRDecoratedTest methodsFor: 'testing-enumerating' stamp: 'lr 10/20/2005 16:44'!
testDecorationsDoOwnerDo
	| elements |
	elements := OrderedCollection new
		add: (self instance 
			addDecoration: (self decorationWithPriority: -5));
		add: (self instance);
		add: (self instance
			addDecoration: (self decorationWithPriority: 10));
		yourself.
	self instance 
		decorationsDo: [ :each | 
			self assert: each = elements removeFirst.
			self deny: each = self instance ]
		ownerDo: [ :each | 
			self assert: each = elements removeFirst.
			self assert: each = self instance ].
	self assert: elements isEmpty.! !

!PRDecoratedTest methodsFor: 'testing' stamp: 'lr 10/20/2005 16:15'!
testInitialized
	self assert: self instance decorations isEmpty.! !

!PRDecoratedTest methodsFor: 'testing-removing' stamp: 'lr 10/20/2005 16:19'!
testRemoveDecoration
	| mock1 mock2 |
	self instance 
		addDecoration: (mock1 := self decorationWithPriority: 1);
		addDecoration: (mock2 := self decorationWithPriority: 2).

	self assert: self instance decorations size = 2.
	self assert: self instance decorations first = mock1.
	self assert: self instance decorations second = mock2.

	self assert: (self instance removeDecoration: mock1) = mock1.
	self assert: self instance decorations size = 1.
	self assert: self instance decorations first = mock2.

	self assert: (self instance removeDecoration: mock2) = mock2.
	self assert: self instance decorations isEmpty.

	self should: [ self instance removeDecoration: mock2 ] raise: Error.
	self assert: self instance decorations isEmpty.! !

!PRDecoratedTest methodsFor: 'testing-removing' stamp: 'lr 10/20/2005 16:20'!
testRemoveDecorationIfAbsent
| mock1 mock2 |
	self instance 
		addDecoration: (mock1 := self decorationWithPriority: 1);
		addDecoration: (mock2 := self decorationWithPriority: 2).

	self assert: self instance decorations size = 2.
	self assert: self instance decorations first = mock1.
	self assert: self instance decorations second = mock2.

	self assert: (self instance removeDecoration: mock1 ifAbsent: [ nil ]) = mock1.
	self assert: self instance decorations size = 1.
	self assert: self instance decorations first = mock2.

	self assert: (self instance removeDecoration: mock2 ifAbsent: [ nil ]) = mock2.
	self assert: self instance decorations isEmpty.

	self assert: (self instance removeDecoration: mock2 ifAbsent: [ nil ]) isNil.
	self assert: self instance decorations isEmpty.! !

PRDecoratedTest subclass: #PRStructureTest
	instanceVariableNames: 'root folder child structure'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Tests-Structure'!

PRStructureTest subclass: #PRFileTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Tests-Structure'!

!PRFileTest class methodsFor: 'testing' stamp: 'lr 12/5/2005 20:49'!
isAbstract
	^ false! !

!PRFileTest methodsFor: 'private' stamp: 'lr 12/5/2005 20:49'!
actualClass
	^ PRFile! !

PRStructureTest subclass: #PRPageTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Tests-Structure'!

!PRPageTest class methodsFor: 'testing' stamp: 'lr 12/5/2005 20:49'!
isAbstract
	^ false! !

!PRPageTest methodsFor: 'private' stamp: 'lr 12/5/2005 20:49'!
actualClass
	^ PRPage! !

!PRStructureTest class methodsFor: 'testing' stamp: 'lr 12/5/2005 20:49'!
isAbstract
	^ true! !

!PRStructureTest methodsFor: 'private' stamp: 'lr 12/5/2005 20:49'!
actualClass
	^ PRStructure! !

!PRStructureTest methodsFor: 'private' stamp: 'lr 12/5/2005 20:46'!
actualInstance
	^ (self actualClass new)
		title: 'structure';
		yourself.! !

!PRStructureTest methodsFor: 'accessing' stamp: 'lr 11/3/2005 08:06'!
child
	^ child! !

!PRStructureTest methodsFor: 'private' stamp: 'lr 11/17/2005 16:09'!
childInstance
	^ PRPage new
		title: 'child';
		yourself.! !

!PRStructureTest methodsFor: 'accessing' stamp: 'lr 11/3/2005 07:58'!
folder
	^ folder! !

!PRStructureTest methodsFor: 'private' stamp: 'lr 11/17/2005 16:09'!
folderInstance
	^ PRPage new
		title: 'folder';
		yourself.! !

!PRStructureTest methodsFor: 'accessing' stamp: 'lr 11/3/2005 08:07'!
instance
	^ structure! !

!PRStructureTest methodsFor: 'accessing' stamp: 'lr 11/3/2005 07:58'!
root
	^ root! !

!PRStructureTest methodsFor: 'private' stamp: 'lr 11/17/2005 16:09'!
rootInstance
	^ PRPage new
		title: 'root';
		yourself.! !

!PRStructureTest methodsFor: 'running' stamp: 'lr 12/5/2005 20:46'!
setUp
	root := self rootInstance.
	folder := self folderInstance.
	child := self childInstance.
	structure := self actualInstance.
	self root addChild: self folder.
	self folder addChild: self child.
	self folder addChild: self structure.! !

!PRStructureTest methodsFor: 'accessing' stamp: 'lr 11/3/2005 08:06'!
structure
	^ structure! !

!PRStructureTest methodsFor: 'testing-children' stamp: 'lr 11/3/2005 08:12'!
testAllChildren
	self assert: (self root allChildren size = 3).
	self assert: (self root allChildren includes: self folder).
	self assert: (self root allChildren includes: self structure).
	self assert: (self root allChildren includes: self child).

	self assert: (self folder allChildren size = 2).
	self assert: (self folder allChildren includes: self child).
	self assert: (self folder allChildren includes: self structure).

	self assert: (self child allChildren isEmpty).
	self assert: (self structure allChildren isEmpty).! !

!PRStructureTest methodsFor: 'testing-testing' stamp: 'lr 11/17/2005 16:09'!
testCanBeChildOf
	PRStructure withAllConcreteClassesDo: [ :each |
		self 
			shouldnt: [ self structure canBeChildOf: each new ]
			raise: Error ].! !

!PRStructureTest methodsFor: 'testing-testing' stamp: 'lr 11/17/2005 16:09'!
testCanBeParentOf
	PRStructure withAllConcreteClassesDo: [ :each |
		self 
			shouldnt: [ self structure canBeParentOf: each new ]
			raise: Error ].! !

!PRStructureTest methodsFor: 'testing-children' stamp: 'lr 11/3/2005 08:13'!
testChildren
	self assert: (self root children size = 1).
	self assert: (self root children includes: self folder).

	self assert: (self folder children size = 2).
	self assert: (self folder children includes: self child).
	self assert: (self folder children includes: self structure).

	self assert: (self child children isEmpty).
	self assert: (self structure children isEmpty).
! !

!PRStructureTest methodsFor: 'testing-copying' stamp: 'lr 11/3/2005 08:14'!
testCopyChildren
	| folderCopy childCopy structureCopy |
	folderCopy := self folder copy.
	childCopy := folderCopy childrenDecoration at: 'child'.
	structureCopy := folderCopy childrenDecoration at: 'structure'.

	self deny: self folder = folderCopy.
	self deny: self child = childCopy.
	self deny: self structure = structureCopy.

	self assert: self folder parent = self root.
	self assert: self child parent = self folder.
	self assert: self structure parent = self folder.

	self assert: folderCopy parent isNil.
	self assert: childCopy parent = folderCopy.
	self assert: structureCopy parent = folderCopy.

! !

!PRStructureTest methodsFor: 'testing-testing' stamp: 'lr 11/3/2005 09:08'!
testHasChildren
	self assert: self root hasChildren.
	self assert: self folder hasChildren.
	self deny: self child hasChildren.
	self deny: self structure hasChildren.! !

!PRStructureTest methodsFor: 'testing-testing' stamp: 'lr 11/3/2005 09:08'!
testHasParent
	self deny: self root hasParent.
	self assert: self folder hasParent.
	self assert: self child hasParent.
	self assert: self structure hasParent.! !

!PRStructureTest methodsFor: 'testing-lookup' stamp: 'lr 11/17/2005 16:09'!
testIncompleteLookup
	| lookup |
	lookup := PRIncompletePathLookup 
		start: self root 
		path: '/folder/zork'.
	self assert: lookup key = self folder.
	self assert: lookup value = 'zork'. 
	
	lookup := PRIncompletePathLookup 
		start: self structure 
		path: '../structure/bar'.
	self assert: lookup key = self structure.
	self assert: lookup value = 'bar'.
	
! !

!PRStructureTest methodsFor: 'testing-lookup' stamp: 'lr 11/17/2005 16:10'!
testIncompleteLookupIgnored
	| lookup |
	lookup := PRIncompletePathLookup 
		start: self folder 
		path: '../folder/child/foo/bar'.
	self assert: lookup key = self child.
	self assert: lookup value = 'foo'.

	lookup := PRIncompletePathLookup 
		start: self folder 
		path: 'foo/bar'.
	self assert: lookup key = self folder.
	self assert: lookup value = 'foo'. ! !

!PRStructureTest methodsFor: 'testing-testing' stamp: 'lr 11/3/2005 09:09'!
testIsAncestorOf
	self assert: (self root isAncestorOf: self root).
	self assert: (self root isAncestorOf: self folder).
	self assert: (self root isAncestorOf: self child).
	self assert: (self root isAncestorOf: self structure).
	
	self deny: (self folder isAncestorOf: self root).
	self assert: (self folder isAncestorOf: self folder).
	self assert: (self folder isAncestorOf: self child).
	self assert: (self folder isAncestorOf: self structure).
	
	self deny: (self child isAncestorOf: self root).
	self deny: (self child isAncestorOf: self folder).
	self assert: (self child isAncestorOf: self child).
	self deny: (self child isAncestorOf: self structure).
	
	self deny: (self structure isAncestorOf: self root).
	self deny: (self structure isAncestorOf: self folder).
	self deny: (self structure isAncestorOf: self child).
	self assert: (self structure isAncestorOf: self structure).! !

!PRStructureTest methodsFor: 'testing-testing' stamp: 'lr 11/3/2005 09:10'!
testIsRoot
	self assert: self root isRoot.
	self deny: self folder isRoot.
	self deny: self child isRoot.
	self deny: self structure isRoot.! !

!PRStructureTest methodsFor: 'testing-accessing' stamp: 'lr 11/3/2005 08:08'!
testLevel
	self assert: self root level = 1.
	self assert: self folder level = 2.
	self assert: self child level = 3.
	self assert: self structure level = 3.! !

!PRStructureTest methodsFor: 'testing-lookup' stamp: 'lr 11/17/2005 16:10'!
testLookupComposed
	self assert: (PRPathLookup start: self child path: '../child/..') = self folder.
	self assert: (PRPathLookup start: self child path: '../child/../') = self folder.

	self assert: (PRPathLookup start: self child path: '../structure/..') = self folder.
	self assert: (PRPathLookup start: self child path: '../structure/../') = self folder.

	self assert: (PRPathLookup start: self child path: '../structure/../child') = self child.
	self assert: (PRPathLookup start: self child path: '../structure/../child/') = self child.

	self assert: (PRPathLookup start: self child path: '../structure/../structure') = self structure.
	self assert: (PRPathLookup start: self child path: '../structure/../structure/') = self structure.! !

!PRStructureTest methodsFor: 'testing-lookup' stamp: 'lr 11/17/2005 16:10'!
testLookupEmpty
	self assert: (PRPathLookup start: self root path: '') = self root.
	self assert: (PRPathLookup start: self folder path: '') = self folder.
	self assert: (PRPathLookup start: self child path: '') = self child.
	self assert: (PRPathLookup start: self structure path: '') = self structure.! !

!PRStructureTest methodsFor: 'testing-lookup' stamp: 'lr 11/17/2005 16:10'!
testLookupError
	self should: [ PRPathLookup start: self root path: 'unknown' ] raise: Error.
	self should: [ PRPathLookup start: self root path: 'unknown/' ] raise: Error.

	self should: [ PRPathLookup start: self root path: 'folder/unknown' ] raise: Error.
	self should: [ PRPathLookup start: self root path: 'folder/unknown/' ] raise: Error.

	self should: [ PRPathLookup start: self root path: 'folder/unknown/unknown' ] raise: Error.
	self should: [ PRPathLookup start: self root path: 'folder/unknown/unknown/' ] raise: Error.

	self should: [ PRPathLookup start: self root path: 'folder/instance/unknown' ] raise: Error.
	self should: [ PRPathLookup start: self root path: 'folder/instance/unknown/' ] raise: Error.! !

!PRStructureTest methodsFor: 'testing-lookup' stamp: 'lr 11/17/2005 16:10'!
testLookupParent
	self assert: (PRPathLookup start: self root path: '..') = self root.
	self assert: (PRPathLookup start: self root path: '../') = self root.
	
	self assert: (PRPathLookup start: self folder path: '..') = self root.
	self assert: (PRPathLookup start: self folder path: '../') = self root.

	self assert: (PRPathLookup start: self child path: '..') = self folder.
	self assert: (PRPathLookup start: self child path: '../') = self folder.

	self assert: (PRPathLookup start: self structure path: '..') = self folder.
	self assert: (PRPathLookup start: self structure path: '../') = self folder.! !

!PRStructureTest methodsFor: 'testing-lookup' stamp: 'lr 11/17/2005 16:10'!
testLookupParentParent
	self assert: (PRPathLookup start: self root path: '../..') = self root.
	self assert: (PRPathLookup start: self root path: '../../') = self root.

	self assert: (PRPathLookup start: self folder path: '../..') = self root.
	self assert: (PRPathLookup start: self folder path: '../../') = self root.

	self assert: (PRPathLookup start: self child path: '../..') = self root.
	self assert: (PRPathLookup start: self child path: '../../') = self root.

	self assert: (PRPathLookup start: self structure path: '../..') = self root.
	self assert: (PRPathLookup start: self structure path: '../..') = self root.! !

!PRStructureTest methodsFor: 'testing-lookup' stamp: 'lr 11/17/2005 16:11'!
testLookupParsing
	self assert: (PRPathLookup new stream: 'abc' readStream; readNext) = 'abc'.
	self assert: (PRPathLookup new stream: 'abc/' readStream; readNext) = 'abc'.
	
	self assert: (PRPathLookup new stream: 'abc/def' readStream; readNext) = 'abc'.
	self assert: (PRPathLookup new stream: 'abc/def/' readStream; readNext) = 'abc'.

	self assert: (PRPathLookup new stream: 'abc//def' readStream; readNext) = 'abc/def'.
	self assert: (PRPathLookup new stream: 'abc//def/' readStream; readNext) = 'abc/def'.

	self assert: (PRPathLookup new stream: 'abc///def' readStream; readNext) = 'abc/'.
	self assert: (PRPathLookup new stream: 'abc///def/' readStream; readNext) = 'abc/'.

	self assert: (PRPathLookup new stream: 'abc////def' readStream; readNext) = 'abc//def'.
	self assert: (PRPathLookup new stream: 'abc////def/' readStream; readNext) = 'abc//def'.! !

!PRStructureTest methodsFor: 'testing-lookup' stamp: 'lr 11/17/2005 16:11'!
testLookupRelative
	self assert: (PRPathLookup start: self structure path: '../structure') = self structure.
	self assert: (PRPathLookup start: self structure path: '../structure/') = self structure.
	
	self assert: (PRPathLookup start: self structure path: '../../folder') = self folder.
	self assert: (PRPathLookup start: self structure path: '../../folder/') = self folder.

	self assert: (PRPathLookup start: self structure path: '../../folder/structure') = self structure.
	self assert: (PRPathLookup start: self structure path: '../../folder/structure/') = self structure.! !

!PRStructureTest methodsFor: 'testing-lookup' stamp: 'lr 11/17/2005 16:11'!
testLookupRoot
	self assert: (PRPathLookup start: self root path: '/') = self root.
	self assert: (PRPathLookup start: self root path: '/folder') = self folder.
	self assert: (PRPathLookup start: self root path: '/folder/child') = self child.
	self assert: (PRPathLookup start: self root path: '/folder/structure') = self structure.

	self assert: (PRPathLookup start: self structure path: '/') = self root.
	self assert: (PRPathLookup start: self structure path: '/folder') = self folder.
	self assert: (PRPathLookup start: self structure path: '/folder/child') = self child.
	self assert: (PRPathLookup start: self structure path: '/folder/structure') = self structure.! !

!PRStructureTest methodsFor: 'testing-accessing' stamp: 'lr 11/3/2005 08:08'!
testParent
	self assert: self root parent = nil.
	self assert: self folder parent = root.
	self assert: self child parent = folder.
	self assert: self structure parent = folder.! !

!PRStructureTest methodsFor: 'testing-accessing' stamp: 'lr 11/3/2005 08:09'!
testParents
	self assert: self root parents size = 1.
	self assert: self root parents first = self root.

	self assert: self folder parents size = 2.
	self assert: self folder parents first = self root.
	self assert: self folder parents second = self folder.

	self assert: self child parents size = 3.
	self assert: self child parents first = self root.
	self assert: self child parents second = self folder.
	self assert: self child parents third = self child.

	self assert: self structure parents size = 3.
	self assert: self structure parents first = self root.
	self assert: self structure parents second = self folder.
	self assert: self structure parents third = self structure.! !

!PRStructureTest methodsFor: 'testing-reference' stamp: 'lr 11/17/2005 16:11'!
testReferenceEmpty
	self assert: (PRPathReference from: self root to: self root) = '/'.

	self assert: (PRPathReference from: self folder to: self folder) = ''.
	self assert: (PRPathReference from: self child to: self child) = ''.
	self assert: (PRPathReference from: self structure to: self structure) = ''.! !

!PRStructureTest methodsFor: 'testing-reference' stamp: 'lr 11/17/2005 16:12'!
testReferenceError
	self should: [ PRPathReference from: self root to: PRPage new ] raise: Error.
	self should: [ PRPathReference from: self folder to: PRPage new ] raise: Error.
	self should: [ PRPathReference from: self child to: PRPage new ] raise: Error.	
	self should: [ PRPathReference from: self structure to: PRPage new ] raise: Error.	

	self should: [ PRPathReference from: PRPage new to: self root  ] raise: Error.
	self should: [ PRPathReference from: PRPage new to: self folder ] raise: Error.
	self should: [ PRPathReference from: PRPage new to: self child ] raise: Error.
	self should: [ PRPathReference from: PRPage new to: self structure ] raise: Error.! !

!PRStructureTest methodsFor: 'testing-reference' stamp: 'lr 11/17/2005 16:12'!
testReferenceEscaping
	| sub1 sub2 |
	sub1 := PRPage new
		title: 'abc/def';
		yourself.
	sub2 := PRPage new
		title: 'ghi//jkl';
		yourself.
	root addChild: sub1.
	sub1 addChild: sub2.

	self assert: (PRPathReference from: self root to: sub1) = '/abc//def'.
	self assert: (PRPathReference from: sub1 to: sub2) = 'ghi////jkl'.
	self assert: (PRPathReference from: self root to: sub2) = '/abc//def/ghi////jkl'.! !

!PRStructureTest methodsFor: 'testing-reference' stamp: 'lr 11/17/2005 16:12'!
testReferenceParent
	self assert: (PRPathReference from: self folder to: self root) = '..'.
	self assert: (PRPathReference from: self child to: self folder) = '..'.
	self assert: (PRPathReference from: self structure to: self folder) = '..'.

	self assert: (PRPathReference from: self child to: self root) = '../..'.
	self assert: (PRPathReference from: self structure to: self root) = '../..'.! !

!PRStructureTest methodsFor: 'testing-reference' stamp: 'lr 11/17/2005 16:13'!
testReferenceRelative
	self assert: (PRPathReference from: self child to: self structure) = '../structure'.
	self assert: (PRPathReference from: self structure to: self child) = '../child'.! !

!PRStructureTest methodsFor: 'testing-reference' stamp: 'lr 11/17/2005 16:14'!
testReferenceRoot
	self assert: (PRPathReference to: self root) = '/'.
	self assert: (PRPathReference to: self folder) = '/folder'.
	self assert: (PRPathReference to: self child) = '/folder/child'.
	self assert: (PRPathReference to: self structure) = '/folder/structure'.

	self assert: (PRPathReference from: self root to: self root) = '/'.
	self assert: (PRPathReference from: self root to: self folder) = '/folder'.
	self assert: (PRPathReference from: self root to: self child) = '/folder/child'.
	self assert: (PRPathReference from: self root to: self structure) = '/folder/structure'.! !

!PRStructureTest methodsFor: 'testing-accessing' stamp: 'lr 11/3/2005 08:09'!
testRoot
	self assert: self root root = self root.
	self assert: self folder root = self root.
	self assert: self child root = self root.
	self assert: self structure root = self root.! !

!PRStructureTest methodsFor: 'testing-accessing' stamp: 'lr 11/3/2005 08:10'!
testTitle
	self assert: self root title = 'root'.
	self assert: self folder title = 'folder'.
	self assert: self child title = 'child'.
	self assert: self structure title = 'structure'.! !

PRObjectTest subclass: #PRDecorationTest
	instanceVariableNames: 'decorated decoration'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Tests-Structure'!

PRDecorationTest subclass: #PRChildrenTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Tests-Structure'!

!PRChildrenTest class methodsFor: 'testing' stamp: 'lr 12/5/2005 20:49'!
isAbstract
	^ false! !

!PRChildrenTest methodsFor: 'private' stamp: 'lr 12/5/2005 20:49'!
actualClass
	^ PRChildren! !

!PRChildrenTest methodsFor: 'private' stamp: 'lr 11/17/2005 15:22'!
firstChildInstance
	^ PRPage new
		title: 'Child 1';
		yourself.! !

!PRChildrenTest methodsFor: 'private' stamp: 'lr 11/17/2005 15:22'!
secondChildInstance
	^ PRPage new
		title: 'Child 2';
		yourself.! !

!PRChildrenTest methodsFor: 'testing-actions' stamp: 'lr 12/20/2005 10:00'!
testAdd
	| child1 child2 |
	child1 := self firstChildInstance.
	self assert: (self decoration add: child1) = child1.
	self assert: self decorated = child1 parent.

	child2 := self secondChildInstance.
	self assert: (self decoration add: child2) = child2.
	self assert: self decorated = child2 parent.! !

!PRChildrenTest methodsFor: 'testing-actions' stamp: 'lr 11/20/2005 23:14'!
testAddInvalid
	| plain empty duplicate parented |
	self decoration add: self firstChildInstance.

	plain := PRPage new.
	empty := PRPage new 
		title: String new; 
		yourself.
	duplicate := PRPage new 
		title: self firstChildInstance title; 
		yourself.
	parented := self secondChildInstance
		parent: self firstChildInstance;
		yourself.

	self should: [ self decoration add: plain ] raise: Error.
	self should: [ self decoration add: empty ] raise: Error.
	self should: [ self decoration add: duplicate ] raise: Error.
	self should: [ self decoration add: parented ] raise: Error.! !

!PRChildrenTest methodsFor: 'testing-accessing' stamp: 'lr 11/6/2005 11:43'!
testAt
	| child1 child2 |
	self decoration
		add: (child1 := self firstChildInstance);
		add: (child2 := self secondChildInstance).

	self assert: (self decoration at: child1 title) = child1.
	self assert: (self decoration at: child2 title) = child2.
	self should: [ self decoration at: 'zork' ] raise: Error.! !

!PRChildrenTest methodsFor: 'testing-accessing' stamp: 'lr 11/6/2005 11:44'!
testAtIfAbsent
	| child1 child2 |
	self decoration
		add: (child1 := self firstChildInstance);
		add: (child2 := self secondChildInstance).

	self assert: (self decoration at: child1 title ifAbsent: [ nil ]) = child1.
	self assert: (self decoration at: child2 title ifAbsent: [ nil ]) = child2.
	self assert: (self decoration at: 'zork' ifAbsent: [ nil ]) isNil.! !

!PRChildrenTest methodsFor: 'testing-accessing' stamp: 'lr 12/12/2005 08:43'!
testAtIfPresent
	| child1 child2 |
	self decoration
		add: (child1 := self firstChildInstance);
		add: (child2 := self secondChildInstance).

	self assert: (self decoration 
		at: child1 title 
		ifPresent: [ :val | val ]) = child1.
	self assert: (self decoration
		at: child2 title 
		ifPresent: [ :val | 'zork' ]) = 'zork'.
	self assert: (self decoration 
		at: 'zork' 
		ifPresent: [ :val | self assert: false ]) isNil.! !

!PRChildrenTest methodsFor: 'testing-accessing' stamp: 'lr 12/12/2005 08:44'!
testIncludes
	| child1 child2 |
	self decoration
		add: (child1 := self firstChildInstance);
		add: (child2 := self secondChildInstance).

	self assert: (self decoration includes: child1 title).
	self assert: (self decoration includes: child2 title).
	self deny: (self decoration includes: 'zork').! !

!PRChildrenTest methodsFor: 'testing-actions' stamp: 'lr 11/5/2005 16:26'!
testRemove
	| child1 child2 |
	self decoration
		add: (child1 := self firstChildInstance);
		add: (child2 := self secondChildInstance).
	self assert: (self decoration remove: child1) = child1.
	self assert: (self decoration remove: child2) = child2.
	self assert: (self decoration isEmpty).! !

!PRChildrenTest methodsFor: 'testing-actions' stamp: 'lr 11/5/2005 16:30'!
testRemoveInvalid
	self decoration add: self firstChildInstance.

	self should: [ self decoration remove: self firstChildInstance ] raise: Error.
	self should: [ self decoration remove: self secondChildInstance ] raise: Error.! !

!PRDecorationTest class methodsFor: 'testing' stamp: 'lr 12/5/2005 20:49'!
isAbstract
	^ true! !

!PRDecorationTest methodsFor: 'private' stamp: 'lr 12/5/2005 20:49'!
actualClass
	^ PRDecoration! !

!PRDecorationTest methodsFor: 'private' stamp: 'lr 12/5/2005 20:46'!
actualInstance
	^ self actualClass new.! !

!PRDecorationTest methodsFor: 'accessing' stamp: 'lr 12/20/2005 09:56'!
decorated
	^ decorated! !

!PRDecorationTest methodsFor: 'private' stamp: 'lr 12/20/2005 09:59'!
decoratedInstance
	^ PRPage new.! !

!PRDecorationTest methodsFor: 'accessing' stamp: 'lr 11/3/2005 08:00'!
decoration
	^ decoration! !

!PRDecorationTest methodsFor: 'accessing' stamp: 'lr 11/3/2005 08:00'!
instance
	^ decoration! !

!PRDecorationTest methodsFor: 'running' stamp: 'lr 12/20/2005 09:59'!
setUp
	decorated := self decoratedInstance.
	decoration := self actualInstance.
	decorated addDecoration: decoration.! !

!PRDecorationTest methodsFor: 'testing-copying' stamp: 'lr 12/20/2005 10:01'!
testCopyDecorated
	| ownerCopy decorationCopy |
	ownerCopy := self decorated copy.
	decorationCopy := ownerCopy decorations first.

	self deny: self decorated = ownerCopy.
	self deny: self decoration = decorationCopy.

	self assert: self decorated decorations size = 1.
	self assert: self decorated decorations first = self decoration.
	self assert: self decorated = self decoration decorated.

	self assert: ownerCopy decorations size = 1.
	self assert: ownerCopy decorations first = decorationCopy.
	self assert: ownerCopy = decorationCopy decorated.! !

!PRDecorationTest methodsFor: 'testing-copying' stamp: 'lr 12/20/2005 18:27'!
testCopyDecoration
	| decorationCopy |
	decorationCopy := self decoration copy.

	self deny: self decoration = decorationCopy.
	self assert: self decoration decorated = self decorated.
	self assert: decorationCopy decorated isNil.
! !

!PRDecorationTest methodsFor: 'testing-accessing' stamp: 'lr 12/20/2005 10:01'!
testDecorated
	self assert: self decoration decorated = self decorated.! !

!PRDecorationTest methodsFor: 'testing-accessing' stamp: 'lr 11/5/2005 16:05'!
testPriority
	self assert: self decoration priority isNumber.! !

!PRDecorationTest methodsFor: 'testing-utilities' stamp: 'lr 12/20/2005 18:25'!
testRemove
	self assert: self decoration remove.
	self assert: self decoration decorated isNil.
	self assert: self decorated decorations isEmpty.! !

PRObjectTest subclass: #PRDocumentItemTest
	instanceVariableNames: 'instance'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Tests-Document'!

PRDocumentItemTest subclass: #PRAnchorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Tests-Document'!

!PRAnchorTest class methodsFor: 'testing' stamp: 'lr 12/5/2005 20:49'!
isAbstract
	^ false! !

!PRAnchorTest methodsFor: 'private' stamp: 'lr 12/5/2005 20:49'!
actualClass
	^ PRAnchor! !

!PRAnchorTest methodsFor: 'testing-comparing' stamp: 'lr 12/5/2005 20:37'!
testEqualName
	self deny: (self actualClass with: 'foo') = (self actualClass with: 'bar')! !

!PRAnchorTest methodsFor: 'testing-accessing' stamp: 'lr 10/20/2005 18:08'!
testName
	self instance name: 'zork'.
	self assert: self instance name = 'zork'.! !

!PRAnchorTest methodsFor: 'testing-parsing' stamp: 'lr 11/17/2005 15:19'!
testParseBasic
	| wiki tree |
	wiki := '@name'.
	tree := PRDocument new
		add: (PRAnchor with: 'name');
		yourself.

	self assertParsing: wiki gives: tree.
	self assertVisiting: tree gives: wiki.! !

!PRAnchorTest methodsFor: 'testing-parsing' stamp: 'lr 11/17/2005 15:22'!
testParseMultiple
	| wiki tree |
	wiki := '@one
@two

@tree'.
	tree := PRDocument new
		add: (PRAnchor with: 'one');
		add: (PRAnchor with: 'two');
		add: PRParagraph new;
		add: (PRAnchor with: 'tree');
		yourself.

	self assertParsing: wiki gives: tree.
	self assertVisiting: tree gives: wiki.! !

!PRAnchorTest methodsFor: 'testing-parsing' stamp: 'lr 11/17/2005 15:22'!
testParseSpaces
	| wiki tree |
	wiki := '@one two'.
	tree := PRDocument new
		add: (PRAnchor with: 'one two');
		yourself.

	self assertParsing: wiki gives: tree.
	self assertVisiting: tree gives: wiki.! !

!PRAnchorTest methodsFor: 'testing-instantiation' stamp: 'lr 12/5/2005 20:37'!
testWith
	instance := self actualClass with: 'test'.
	self assert: self instance name = 'test'! !

PRDocumentItemTest subclass: #PRDocumentGroupTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Tests-Document'!

!PRDocumentGroupTest class methodsFor: 'testing' stamp: 'lr 12/5/2005 20:49'!
isAbstract
	^ true! !

!PRDocumentGroupTest methodsFor: 'private' stamp: 'lr 12/5/2005 20:49'!
actualClass
	^ PRDocumentGroup! !

!PRDocumentGroupTest methodsFor: 'testing-adding' stamp: 'lr 10/31/2005 19:37'!
testAdd
	self instance add: self fooInstance.
	self assert: self instance children size = 1.
	self assert: self instance children first = self fooInstance.

	self instance add: self barInstance.
	self assert: self instance children size = 2.
	self assert: self instance children first = self fooInstance.
	self assert: self instance children second = self barInstance.
! !

!PRDocumentGroupTest methodsFor: 'testing-adding' stamp: 'lr 10/31/2005 19:38'!
testAddAll
	self instance addAll: self foobarInstances.
	self assert: self instance children size = 2.
	self assert: self instance children first = self fooInstance.
	self assert: self instance children second = self barInstance.! !

!PRDocumentGroupTest methodsFor: 'testing-copying' stamp: 'lr 10/31/2005 19:39'!
testCopyChildren
	self instance addAll: self foobarInstances.
	self assert: self instance children = self instance copy children.
	self deny: self instance children == self instance copy children.
	self instance children 
		with: self instance copy children 
		do: [ :a :b | self assert: a = b. self deny: a == b ]. ! !

!PRDocumentGroupTest methodsFor: 'testing-testing' stamp: 'lr 10/31/2005 19:41'!
testHasChildren
	self deny: self instance hasChildren.

	self instance add: self fooInstance.
	self assert: self instance hasChildren.

	self instance remove: self fooInstance.
	self deny: self instance hasChildren.! !

!PRDocumentGroupTest methodsFor: 'testing-removing' stamp: 'lr 10/31/2005 19:41'!
testRemove
	self instance addAll: self foobarInstances.
	self assert: self instance children size = 2.
	self assert: self instance children first = self fooInstance.
	self assert: self instance children second = self barInstance.

	self instance remove: self fooInstance.
	self assert: self instance children size = 1.
	self assert: self instance children first = self barInstance..

	self instance remove: self fooInstance.	
	self assert: self instance children size = 1.
	self assert: self instance children first = self barInstance.

	self instance remove: self barInstance.
	self assert: self instance children isEmpty.! !

!PRDocumentGroupTest methodsFor: 'testing-accessing' stamp: 'lr 10/31/2005 19:38'!
testText
	self instance addAll: self foobarInstances.
	self assert: self instance text = 'foobar'.! !

!PRDocumentGroupTest methodsFor: 'testing-instantiation' stamp: 'lr 12/5/2005 20:37'!
testWith
	instance := self actualClass with: self fooInstance.
	self assert: instance children size = 1.
	self assert: instance children first = self fooInstance! !

!PRDocumentGroupTest methodsFor: 'testing-instantiation' stamp: 'lr 12/5/2005 20:37'!
testWithAll
	instance := self actualClass withAll: self foobarInstances.
	self assert: instance children size = 2.
	self assert: instance children first = self fooInstance.
	self assert: instance children second = self barInstance! !

PRDocumentGroupTest subclass: #PRDocumentTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Tests-Document'!

!PRDocumentTest class methodsFor: 'testing' stamp: 'lr 12/5/2005 20:49'!
isAbstract
	^ false! !

!PRDocumentTest methodsFor: 'private' stamp: 'lr 12/5/2005 20:49'!
actualClass
	^ PRDocument! !

!PRDocumentTest methodsFor: 'testing-parsing' stamp: 'lr 11/17/2005 15:44'!
testParseBasic
	| wiki tree |
	wiki := String new.
	tree := PRDocument new.

	self assertParsing: wiki gives: tree.
	self assertVisiting: tree gives: wiki.! !

PRDocumentGroupTest subclass: #PRHeaderTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Tests-Document'!

!PRHeaderTest class methodsFor: 'testing' stamp: 'lr 12/5/2005 20:49'!
isAbstract
	^ false! !

!PRHeaderTest methodsFor: 'private' stamp: 'lr 12/5/2005 20:49'!
actualClass
	^ PRHeader! !

!PRHeaderTest methodsFor: 'testing-comparing' stamp: 'lr 12/5/2005 20:37'!
testEqualLevel
	self 
		deny: (self actualClass new level: 1) = (self actualClass new level: 2)! !

!PRHeaderTest methodsFor: 'testing-accessing' stamp: 'lr 10/31/2005 19:26'!
testName
	self instance level: 3.
	self assert: self instance level = 3.! !

!PRHeaderTest methodsFor: 'testing-parsing' stamp: 'lr 11/17/2005 15:45'!
testParseLevel1
	| wiki tree |
	wiki := '!!foo'.
	tree := PRDocument new
		add: (PRHeader new
			level: 1;
			add: (PRText with: 'foo');
			yourself);
		yourself.

	self assertParsing: wiki gives: tree.
	self assertVisiting: tree gives: wiki.! !

!PRHeaderTest methodsFor: 'testing-parsing' stamp: 'lr 11/17/2005 15:45'!
testParseLevel2
	| wiki tree |
	wiki := '!!!!foo'.
	tree := PRDocument new
		add: (PRHeader new
			level: 2;
			add: (PRText with: 'foo');
			yourself);
		yourself.

	self assertParsing: wiki gives: tree.
	self assertVisiting: tree gives: wiki.! !

!PRHeaderTest methodsFor: 'testing-parsing' stamp: 'lr 11/17/2005 15:45'!
testParseLevel3
	| wiki tree |
	wiki := '!!!!!!foo'.
	tree := PRDocument new
		add: (PRHeader new
			level: 3;
			add: (PRText with: 'foo');
			yourself);
		yourself.

	self assertParsing: wiki gives: tree.
	self assertVisiting: tree gives: wiki.! !

!PRHeaderTest methodsFor: 'testing-parsing' stamp: 'lr 11/17/2005 15:45'!
testParseLevel4
	| wiki tree |
	wiki := '!!!!!!!!foo'.
	tree := PRDocument new
		add: (PRHeader new
			level: 4;
			add: (PRText with: 'foo');
			yourself);
		yourself.

	self assertParsing: wiki gives: tree.
	self assertVisiting: tree gives: wiki.! !

!PRHeaderTest methodsFor: 'testing-parsing' stamp: 'lr 11/17/2005 15:46'!
testParseLevel5
	| wiki tree |
	wiki := '!!!!!!!!!!foo'.
	tree := PRDocument new
		add: (PRHeader new
			level: 5;
			add: (PRText with: 'foo');
			yourself);
		yourself.

	self assertParsing: wiki gives: tree.
	self assertVisiting: tree gives: wiki.! !

!PRHeaderTest methodsFor: 'testing-parsing' stamp: 'lr 11/17/2005 15:46'!
testParseLevel6
	| wiki tree |
	wiki := '!!!!!!!!!!!!foo'.
	tree := PRDocument new
		add: (PRHeader new
			level: 6;
			add: (PRText with: 'foo');
			yourself);
		yourself.

	self assertParsing: wiki gives: tree.
	self assertVisiting: tree gives: wiki.! !

!PRHeaderTest methodsFor: 'testing-parsing' stamp: 'lr 11/17/2005 15:52'!
testParseNested
	| wiki tree |
	wiki := '!!!!Smiley :-) and *Link*'.
	tree := PRDocument new
		add: (PRHeader new
			level: 2;
			add: (PRText with: 'Smiley ');
			add: (PRSmiley with: ':-)');
			add: (PRText with: ' and ');
			add: (PRInternalLink new
				reference: 'Link';
				yourself);
			yourself);
		yourself.

	self assertParsing: wiki gives: tree.
	self assertVisiting: tree gives: wiki.! !

!PRHeaderTest methodsFor: 'testing-instantiation' stamp: 'lr 12/5/2005 20:37'!
testWithAllLevel
	instance := self actualClass withAll: self foobarInstances level: 3.
	self assert: self instance children size = 2.
	self assert: self instance children first = self fooInstance.
	self assert: self instance children second = self barInstance.
	self assert: self instance level = 3! !

!PRHeaderTest methodsFor: 'testing-instantiation' stamp: 'lr 12/5/2005 20:37'!
testWithLevel
	instance := self actualClass with: self fooInstance level: 2.
	self assert: self instance children size = 1.
	self assert: self instance children first = self fooInstance.
	self assert: self instance level = 2! !

PRDocumentGroupTest subclass: #PRLinkTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Tests-Document'!

PRLinkTest subclass: #PRExternalLinkTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Tests-Document'!

!PRExternalLinkTest class methodsFor: 'testing' stamp: 'lr 12/5/2005 20:49'!
isAbstract
	^ false! !

!PRExternalLinkTest methodsFor: 'private' stamp: 'lr 12/5/2005 20:49'!
actualClass
	^ PRExternalLink! !

!PRExternalLinkTest methodsFor: 'private' stamp: 'lr 11/2/2005 21:18'!
referenceString
	^ 'http://www.lukas-renggli.ch'! !

!PRExternalLinkTest methodsFor: 'testing-accessing' stamp: 'lr 10/31/2005 22:04'!
testUrl
	self instance reference: 'http://www.lukas-renggli.ch'.
	self assert: self instance url = 'http://www.lukas-renggli.ch'.! !

PRExternalLinkTest subclass: #PRIsbnLinkTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Tests-Document'!

!PRIsbnLinkTest class methodsFor: 'testing' stamp: 'lr 12/5/2005 20:49'!
isAbstract
	^ false! !

!PRIsbnLinkTest methodsFor: 'private' stamp: 'lr 12/5/2005 20:49'!
actualClass
	^ PRIsbnLink! !

!PRIsbnLinkTest methodsFor: 'private' stamp: 'lr 11/2/2005 21:19'!
referenceString
	^ 'isbn:1590594916'! !

!PRIsbnLinkTest methodsFor: 'testing-accessing' stamp: 'lr 10/31/2005 22:04'!
testUrl
	self instance reference: 'isbn:1590594916'.
	self assert: self instance url = 'http://www.amazon.com/exec/obidos/ISBN=1590594916'.! !

PRExternalLinkTest subclass: #PRMailLinkTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Tests-Document'!

!PRMailLinkTest class methodsFor: 'testing' stamp: 'lr 12/5/2005 20:49'!
isAbstract
	^ false! !

!PRMailLinkTest methodsFor: 'private' stamp: 'lr 12/5/2005 20:49'!
actualClass
	^ PRMailLink! !

!PRMailLinkTest methodsFor: 'private' stamp: 'lr 11/2/2005 21:19'!
referenceString
	^ 'renggli@iam.unibe.ch'! !

!PRMailLinkTest methodsFor: 'testing-accessing' stamp: 'lr 10/31/2005 22:03'!
testUrl
	self instance reference: 'renggli@iam.unibe.ch'.
	self assert: self instance url = 'mailto:renggli@iam.unibe.ch'.! !

PRExternalLinkTest subclass: #PRRfcLinkTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Tests-Document'!

!PRRfcLinkTest class methodsFor: 'testing' stamp: 'lr 12/5/2005 20:49'!
isAbstract
	^ false! !

!PRRfcLinkTest methodsFor: 'private' stamp: 'lr 12/5/2005 20:49'!
actualClass
	^ PRRfcLink! !

!PRRfcLinkTest methodsFor: 'private' stamp: 'lr 11/2/2005 21:19'!
referenceString
	^ 'rfc:1896'! !

!PRRfcLinkTest methodsFor: 'testing-accessing' stamp: 'lr 10/31/2005 22:03'!
testUrl
	self instance reference: 'rfc:1896'.
	self assert: self instance url = 'http://www.faqs.org/rfcs/rfc1896.html'.! !

PRLinkTest subclass: #PRInternalLinkTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Tests-Document'!

!PRInternalLinkTest class methodsFor: 'testing' stamp: 'lr 12/5/2005 20:49'!
isAbstract
	^ false! !

!PRInternalLinkTest methodsFor: 'private' stamp: 'lr 12/5/2005 20:49'!
actualClass
	^ PRInternalLink! !

!PRInternalLinkTest methodsFor: 'private' stamp: 'lr 11/2/2005 21:19'!
referenceString
	^ 'Page'! !

!PRInternalLinkTest methodsFor: 'testing-accessing' stamp: 'lr 10/31/2005 22:01'!
testAnchor
	self instance anchor: 'zork'.
	self assert: self instance anchor = 'zork'.
	self assert: self instance hasAnchor.! !

!PRInternalLinkTest methodsFor: 'testing-comparing' stamp: 'lr 12/5/2005 20:37'!
testEqualAnchor
	self 
		deny: ((self actualClass new)
				anchor: 'foo';
				yourself) = ((self actualClass new)
							anchor: 'bar';
							yourself)! !

!PRInternalLinkTest methodsFor: 'testing-parsing' stamp: 'lr 12/5/2005 20:37'!
testParseAnchored
	| wiki tree |
	wiki := '*' , self referenceString , '@Anchor*'.
	tree := (PRDocument new)
				add: ((PRParagraph new)
							add: ((self actualClass new)
										reference: self referenceString;
										anchor: 'Anchor';
										yourself);
							yourself);
				yourself.
	self assertParsing: wiki gives: tree.
	self assertVisiting: tree gives: wiki! !

!PRInternalLinkTest methodsFor: 'testing-parsing' stamp: 'lr 12/5/2005 20:37'!
testParseAnchoredEmbedded
	| wiki tree |
	wiki := '+' , self referenceString , '@Anchor+'.
	tree := (PRDocument new)
				add: ((PRParagraph new)
							add: ((self actualClass new)
										reference: self referenceString;
										anchor: 'Anchor';
										embedded: true;
										yourself);
							yourself);
				yourself.
	self assertParsing: wiki gives: tree.
	self assertVisiting: tree gives: wiki! !

!PRInternalLinkTest methodsFor: 'testing-parsing' stamp: 'lr 12/5/2005 20:37'!
testParseEverything
	| wiki tree |
	wiki := '*Alias>' , self referenceString , '@Anchor*'.
	tree := (PRDocument new)
				add: ((PRParagraph new)
							add: ((self actualClass new)
										add: (PRText with: 'Alias');
										reference: self referenceString;
										anchor: 'Anchor';
										yourself);
							yourself);
				yourself.
	self assertParsing: wiki gives: tree.
	self assertVisiting: tree gives: wiki! !

!PRInternalLinkTest methodsFor: 'testing-parsing' stamp: 'lr 12/5/2005 20:37'!
testParseEverythingEmbedded
	| wiki tree |
	wiki := '+Alias>' , self referenceString , '@Anchor+'.
	tree := (PRDocument new)
				add: ((PRParagraph new)
							add: ((self actualClass new)
										add: (PRText with: 'Alias');
										reference: self referenceString;
										anchor: 'Anchor';
										embedded: true;
										yourself);
							yourself);
				yourself.
	self assertParsing: wiki gives: tree.
	self assertVisiting: tree gives: wiki! !

!PRLinkTest class methodsFor: 'testing' stamp: 'lr 12/5/2005 20:49'!
isAbstract
	^ true! !

!PRLinkTest methodsFor: 'private' stamp: 'lr 12/5/2005 20:49'!
actualClass
	^ PRLink! !

!PRLinkTest methodsFor: 'private' stamp: 'lr 11/2/2005 21:55'!
referenceString
	self subclassResponsibility.! !

!PRLinkTest methodsFor: 'testing-accessing' stamp: 'lr 10/31/2005 20:44'!
testAlias
	self deny: self instance hasAlias.

	self instance add: self fooInstance.
	self assert: self instance hasAlias.
	self assert: self instance alias = 'foo'.

	self instance add: self barInstance.
	self assert: self instance hasAlias.
	self assert: self instance alias = 'foobar'.! !

!PRLinkTest methodsFor: 'testing-accessing' stamp: 'lr 10/31/2005 20:51'!
testAnchor
	self deny: self instance hasAnchor.! !

!PRLinkTest methodsFor: 'testing-accessing' stamp: 'lr 10/31/2005 20:39'!
testEmbedded
	self instance embedded: true.
	self assert: self instance isEmbedded.

	self instance embedded: false.
	self deny: self instance isEmbedded.! !

!PRLinkTest methodsFor: 'testing-comparing' stamp: 'lr 12/5/2005 20:37'!
testEqualEmbedded
	self 
		deny: ((self actualClass new)
				embedded: false;
				yourself) = ((self actualClass new)
							embedded: true;
							yourself)! !

!PRLinkTest methodsFor: 'testing-comparing' stamp: 'lr 12/5/2005 20:37'!
testEqualReference
	self 
		deny: ((self actualClass new)
				reference: 'foo';
				yourself) = ((self actualClass new)
							reference: 'bar';
							yourself)! !

!PRLinkTest methodsFor: 'testing-parsing' stamp: 'lr 12/5/2005 20:37'!
testParseAliased
	| wiki tree |
	wiki := '*Alias>' , self referenceString , '*'.
	tree := (PRDocument new)
				add: ((PRParagraph new)
							add: ((self actualClass new)
										add: (PRText with: 'Alias');
										reference: self referenceString;
										yourself);
							yourself);
				yourself.
	self assertParsing: wiki gives: tree.
	self assertVisiting: tree gives: wiki! !

!PRLinkTest methodsFor: 'testing-parsing' stamp: 'lr 12/5/2005 20:37'!
testParseBasic
	| wiki tree |
	wiki := '*' , self referenceString , '*'.
	tree := (PRDocument new)
				add: ((PRParagraph new)
							add: ((self actualClass new)
										reference: self referenceString;
										yourself);
							yourself);
				yourself.
	self assertParsing: wiki gives: tree.
	self assertVisiting: tree gives: wiki! !

!PRLinkTest methodsFor: 'testing-parsing' stamp: 'lr 11/17/2005 16:01'!
testParseEasyness
	| wiki1 wiki2 tree |
	wiki1 := '*
*' , self referenceString.
	wiki2 := '\*
\*' , self referenceString.
	tree := PRDocument new
		add: (PRParagraph new
			add: (PRText with: '*');
			yourself);
		add: (PRParagraph new
			add: (PRText with: '*' , self referenceString);
			yourself);
		yourself.

	self assertParsing: wiki1 gives: tree.
	self assertParsing: wiki2 gives: tree.
	self assertVisiting: tree gives: wiki2.! !

!PRLinkTest methodsFor: 'testing-parsing' stamp: 'lr 11/17/2005 16:01'!
testParseEasynessEmbedded
	| wiki1 wiki2 tree |
	wiki1 := '+
+' , self referenceString.
	wiki2 := '\+
\+' , self referenceString.
	tree := PRDocument new
		add: (PRParagraph new
			add: (PRText with: '+');
			yourself);
		add: (PRParagraph new
			add: (PRText with: '+' , self referenceString);
			yourself);
		yourself.

	self assertParsing: wiki1 gives: tree.
	self assertParsing: wiki2 gives: tree.
	self assertVisiting: tree gives: wiki2.! !

!PRLinkTest methodsFor: 'testing-parsing' stamp: 'lr 12/5/2005 20:37'!
testParseEmbeddedAliased
	| wiki tree |
	wiki := '+Alias>' , self referenceString , '+'.
	tree := (PRDocument new)
				add: ((PRParagraph new)
							add: ((self actualClass new)
										add: (PRText with: 'Alias');
										reference: self referenceString;
										embedded: true;
										yourself);
							yourself);
				yourself.
	self assertParsing: wiki gives: tree.
	self assertVisiting: tree gives: wiki! !

!PRLinkTest methodsFor: 'testing-parsing' stamp: 'lr 12/5/2005 20:37'!
testParseEmbeddedBasic
	| wiki tree |
	wiki := '+' , self referenceString , '+'.
	tree := (PRDocument new)
				add: ((PRParagraph new)
							add: ((self actualClass new)
										reference: self referenceString;
										embedded: true;
										yourself);
							yourself);
				yourself.
	self assertParsing: wiki gives: tree.
	self assertVisiting: tree gives: wiki! !

!PRLinkTest methodsFor: 'testing-parsing' stamp: 'lr 11/17/2005 16:01'!
testParseEscaped
	| wiki tree |
	wiki := 'Star \*' , self referenceString , '\*
Cross \+' , self referenceString , '\+'.
	tree := PRDocument new
		add: (PRParagraph new
			add: (PRText with: 'Star *' , self referenceString , '*');
			yourself);
		add: (PRParagraph new
			add: (PRText with: 'Cross +' , self referenceString , '+');
			yourself);
		yourself.

	self assertParsing: wiki gives: tree.
	self assertVisiting: tree gives: wiki.! !

!PRLinkTest methodsFor: 'testing-accessing' stamp: 'lr 10/31/2005 20:45'!
testReference
	self instance reference: 'zork'.
	self assert: self instance reference = 'zork'.! !

PRDocumentGroupTest subclass: #PRListItemTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Tests-Document'!

!PRListItemTest class methodsFor: 'testing' stamp: 'lr 12/5/2005 20:49'!
isAbstract
	^ false! !

!PRListItemTest methodsFor: 'private' stamp: 'lr 12/5/2005 20:49'!
actualClass
	^ PRListItem! !

PRDocumentGroupTest subclass: #PRListTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Tests-Document'!

!PRListTest class methodsFor: 'testing' stamp: 'lr 12/5/2005 20:49'!
isAbstract
	^ true! !

!PRListTest methodsFor: 'private' stamp: 'lr 12/5/2005 20:49'!
actualClass
	^ PRList! !

!PRListTest methodsFor: 'private' stamp: 'lr 11/2/2005 21:55'!
elementString
	self subclassResponsibility.! !

!PRListTest methodsFor: 'private' stamp: 'lr 11/17/2005 16:02'!
listItemWithText: aString
	^ PRListItem new
		add: (PRText with: aString);
		yourself.! !

!PRListTest methodsFor: 'testing-parsing' stamp: 'lr 12/5/2005 20:37'!
testParseFlat
	| wiki tree |
	wiki := self elementString , '1st
' , self elementString , '2nd
' 
				, self elementString , '3rd'.
	tree := (PRDocument new)
				add: ((self actualClass new)
							add: (self listItemWithText: '1st');
							add: (self listItemWithText: '2nd');
							add: (self listItemWithText: '3rd');
							yourself);
				yourself.
	self assertParsing: wiki gives: tree.
	self assertVisiting: tree gives: wiki! !

!PRListTest methodsFor: 'testing-parsing' stamp: 'lr 11/17/2005 16:13'!
testParseMixed
	| wiki tree |
	wiki := '#1
#2
-3'.
	tree := PRDocument new
		add: (PROrderedList new
			add: (self listItemWithText: '1');
			add: (self listItemWithText: '2');
			yourself);
		add: (PRUnorderedList new
			add: (self listItemWithText: '3');
			yourself);
		yourself.

	self assertParsing: wiki gives: tree.
	self assertVisiting: tree gives: wiki.! !

!PRListTest methodsFor: 'testing-parsing' stamp: 'lr 12/5/2005 20:37'!
testParseMultiple
	| wiki tree |
	wiki := self elementString , '1st
' , self elementString , '2nd

' 
				, self elementString , '3rd'.
	tree := (PRDocument new)
				add: ((self actualClass new)
							add: (self listItemWithText: '1st');
							add: (self listItemWithText: '2nd');
							yourself);
				add: PRParagraph new;
				add: ((self actualClass new)
							add: (self listItemWithText: '3rd');
							yourself);
				yourself.
	self assertParsing: wiki gives: tree.
	self assertVisiting: tree gives: wiki! !

!PRListTest methodsFor: 'testing-parsing' stamp: 'lr 12/5/2005 20:37'!
testParseNested1
	| wiki tree |
	wiki := self elementString , '1
' , self elementString 
				, self elementString , '1.1
' 
				, self elementString , self elementString 
				, '1.2'.
	tree := (PRDocument new)
				add: ((self actualClass new)
							add: ((PRListItem new)
										add: (PRText with: '1');
										add: ((self actualClass new)
													add: (self listItemWithText: '1.1');
													add: (self listItemWithText: '1.2');
													yourself);
										yourself);
							yourself);
				yourself.
	self assertParsing: wiki gives: tree.
	self assertVisiting: tree gives: wiki! !

!PRListTest methodsFor: 'testing-parsing' stamp: 'lr 12/5/2005 20:37'!
testParseNested2
	| wiki tree |
	wiki := self elementString , '1
' , self elementString 
				, self elementString , '1.1
' 
				, self elementString , self elementString 
				, self elementString , '1.1.1'.
	tree := (PRDocument new)
				add: ((self actualClass new)
							add: ((PRListItem new)
										add: (PRText with: '1');
										add: ((self actualClass new)
													add: ((PRListItem new)
																add: (PRText with: '1.1');
																add: ((self actualClass new)
																			add: (self listItemWithText: '1.1.1');
																			yourself);
																yourself);
													yourself);
										yourself);
							yourself);
				yourself.
	self assertParsing: wiki gives: tree.
	self assertVisiting: tree gives: wiki! !

!PRListTest methodsFor: 'testing-parsing' stamp: 'lr 12/5/2005 20:37'!
testParseNested3
	| wiki tree |
	wiki := self elementString , '1
' , self elementString , '#1.1
' 
				, self elementString , '#1.2
' 
				, self elementString , '-1.3'.
	tree := (PRDocument new)
				add: ((self actualClass new)
							add: ((PRListItem new)
										add: (PRText with: '1');
										add: ((PROrderedList new)
													add: (self listItemWithText: '1.1');
													add: (self listItemWithText: '1.2');
													yourself);
										add: ((PRUnorderedList new)
													add: (self listItemWithText: '1.3');
													yourself);
										yourself);
							yourself);
				yourself.
	self assertParsing: wiki gives: tree.
	self assertVisiting: tree gives: wiki! !

PRListTest subclass: #PROrderedListTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Tests-Document'!

!PROrderedListTest class methodsFor: 'testing' stamp: 'lr 12/5/2005 20:49'!
isAbstract
	^ false! !

!PROrderedListTest methodsFor: 'private' stamp: 'lr 12/5/2005 20:49'!
actualClass
	^ PROrderedList! !

!PROrderedListTest methodsFor: 'private' stamp: 'lr 11/2/2005 19:19'!
elementString
	^ '#'! !

PRListTest subclass: #PRUnorderedListTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Tests-Document'!

!PRUnorderedListTest class methodsFor: 'testing' stamp: 'lr 12/5/2005 20:49'!
isAbstract
	^ false! !

!PRUnorderedListTest methodsFor: 'private' stamp: 'lr 12/5/2005 20:49'!
actualClass
	^ PRUnorderedList! !

!PRUnorderedListTest methodsFor: 'private' stamp: 'lr 11/2/2005 19:19'!
elementString
	^ '-'! !

PRDocumentGroupTest subclass: #PRParagraphTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Tests-Document'!

!PRParagraphTest class methodsFor: 'testing' stamp: 'lr 12/5/2005 20:49'!
isAbstract
	^ false! !

!PRParagraphTest methodsFor: 'private' stamp: 'lr 12/5/2005 20:49'!
actualClass
	^ PRParagraph! !

!PRParagraphTest methodsFor: 'testing-parsing' stamp: 'lr 11/17/2005 16:04'!
testParseBasic
	| wiki tree |
	wiki := 'Lorem ipsum dolor sit amet, consectetuer adipiscing elit. Nulla quis urna. Vestibulum turpis. Duis non mauris non sapien consectetuer vulputate. Duis quis pede. Nullam libero. Mauris ut turpis.'.
	tree := PRDocument new
		add: (PRParagraph new
			add: (PRText with: 'Lorem ipsum dolor sit amet, consectetuer adipiscing elit. Nulla quis urna. Vestibulum turpis. Duis non mauris non sapien consectetuer vulputate. Duis quis pede. Nullam libero. Mauris ut turpis.');
			yourself);
		yourself.

	self assertParsing: wiki gives: tree.
	self assertVisiting: tree gives: wiki.! !

!PRParagraphTest methodsFor: 'testing-parsing' stamp: 'lr 11/17/2005 16:04'!
testParseClose
	| wiki tree |
	wiki := 'Lorem ipsum dolor sit amet, consectetuer adipiscing elit. Nulla quis urna. Vestibulum turpis. Duis non mauris non sapien consectetuer vulputate. Duis quis pede. Nullam libero. Mauris ut turpis.
Nulla mattis elementum nulla. Duis pretium magna et sem. Phasellus blandit. Ut non dolor at pede auctor semper. Donec semper dignissim ipsum. Nunc ultrices dui id ligula. Pellentesque neque. Aenean placerat nunc ut diam. Vivamus luctus magna vel velit. Donec ultricies orci eget erat. Nulla elementum ligula non est.'.
	tree := PRDocument new
		add: (PRParagraph new
			add: (PRText with: 'Lorem ipsum dolor sit amet, consectetuer adipiscing elit. Nulla quis urna. Vestibulum turpis. Duis non mauris non sapien consectetuer vulputate. Duis quis pede. Nullam libero. Mauris ut turpis.');
			yourself);
		add: (PRParagraph new
			add: (PRText with: 'Nulla mattis elementum nulla. Duis pretium magna et sem. Phasellus blandit. Ut non dolor at pede auctor semper. Donec semper dignissim ipsum. Nunc ultrices dui id ligula. Pellentesque neque. Aenean placerat nunc ut diam. Vivamus luctus magna vel velit. Donec ultricies orci eget erat. Nulla elementum ligula non est.');
			yourself);
		yourself.

	self assertParsing: wiki gives: tree.
	self assertVisiting: tree gives: wiki.! !

!PRParagraphTest methodsFor: 'testing-parsing' stamp: 'lr 11/17/2005 16:04'!
testParseSpare
	| wiki tree |
	wiki := 'Lorem ipsum dolor sit amet, consectetuer adipiscing elit. Nulla quis urna. Vestibulum turpis. Duis non mauris non sapien consectetuer vulputate. Duis quis pede. Nullam libero. Mauris ut turpis.

Nulla mattis elementum nulla. Duis pretium magna et sem. Phasellus blandit. Ut non dolor at pede auctor semper. Donec semper dignissim ipsum. Nunc ultrices dui id ligula. Pellentesque neque. Aenean placerat nunc ut diam. Vivamus luctus magna vel velit. Donec ultricies orci eget erat. Nulla elementum ligula non est.'.
	tree := PRDocument new
		add: (PRParagraph new
			add: (PRText with: 'Lorem ipsum dolor sit amet, consectetuer adipiscing elit. Nulla quis urna. Vestibulum turpis. Duis non mauris non sapien consectetuer vulputate. Duis quis pede. Nullam libero. Mauris ut turpis.');
			yourself);
		add: (PRParagraph new);
		add: (PRParagraph new
			add: (PRText with: 'Nulla mattis elementum nulla. Duis pretium magna et sem. Phasellus blandit. Ut non dolor at pede auctor semper. Donec semper dignissim ipsum. Nunc ultrices dui id ligula. Pellentesque neque. Aenean placerat nunc ut diam. Vivamus luctus magna vel velit. Donec ultricies orci eget erat. Nulla elementum ligula non est.');
			yourself);
		yourself.

	self assertParsing: wiki gives: tree.
	self assertVisiting: tree gives: wiki.! !

PRDocumentGroupTest subclass: #PRPreformattedTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Tests-Document'!

!PRPreformattedTest class methodsFor: 'testing' stamp: 'lr 12/5/2005 20:49'!
isAbstract
	^ false! !

!PRPreformattedTest methodsFor: 'private' stamp: 'lr 12/5/2005 20:49'!
actualClass
	^ PRPreformatted! !

!PRPreformattedTest methodsFor: 'testing-parsing' stamp: 'lr 11/17/2005 16:04'!
testParseBasic
	| wiki tree |
	wiki := '=Line'.
	tree := PRDocument new
		add: (PRPreformatted new
			add: (PRText with: 'Line');
			yourself);
		yourself.

	self assertParsing: wiki gives: tree.
	self assertVisiting: tree gives: wiki.! !

!PRPreformattedTest methodsFor: 'testing-parsing' stamp: 'lr 11/17/2005 16:05'!
testParseMultiple
	| wiki tree |
	wiki := '=line 1.1
=line 1.2

=line 2.1'.
	tree := PRDocument new
		add: (PRPreformatted new
			add: (PRText with: 'line 1.1');
			add: (PRText with: 'line 1.2');
			yourself);
		add: (PRParagraph new);
		add: (PRPreformatted new
			add: (PRText with: 'line 2.1');
			yourself);
		yourself.

	self assertParsing: wiki gives: tree.
	self assertVisiting: tree gives: wiki.! !

!PRPreformattedTest methodsFor: 'testing-parsing' stamp: 'lr 11/17/2005 16:05'!
testParseSpaces
	| wiki tree |
	wiki := '=   A line with 3 spaces
=	A line with a tab'.
	tree := PRDocument new
		add: (PRPreformatted new
			add: (PRText with: '   A line with 3 spaces');
			add: (PRText with: '	A line with a tab');
			yourself);
		yourself.

	self assertParsing: wiki gives: tree.
	self assertVisiting: tree gives: wiki.! !

!PRPreformattedTest methodsFor: 'testing-parsing' stamp: 'lr 11/17/2005 16:05'!
testParseSpecials
	| wiki tree |
	wiki := '=|, {, }, *, *, [, ||, |{, |}, +, +'.
	tree := PRDocument new
		add: (PRPreformatted new
			add: (PRText with: '|, {, }, *, *, [, ||, |{, |}, +, +');
			yourself);
		yourself.

	self assertParsing: wiki gives: tree.
	self assertVisiting: tree gives: wiki.! !

PRDocumentGroupTest subclass: #PRTableCellTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Tests-Document'!

!PRTableCellTest class methodsFor: 'testing' stamp: 'lr 12/5/2005 20:49'!
isAbstract
	^ false! !

!PRTableCellTest methodsFor: 'private' stamp: 'lr 12/5/2005 20:49'!
actualClass
	^ PRTableCell! !

!PRTableCellTest methodsFor: 'testing-accessing' stamp: 'lr 10/31/2005 20:04'!
testAlign
	self instance align: #right.
	self assert: self instance align = #right.! !

!PRTableCellTest methodsFor: 'testing-accessing' stamp: 'lr 10/31/2005 20:06'!
testBeAlignedCenter
	self instance beAlignedCenter.
	self assert: self instance align = #center.
	self assert: self instance isAlignedCenter.
	self deny: self instance isAlignedLeft.
	self deny: self instance isAlignedRight.! !

!PRTableCellTest methodsFor: 'testing-accessing' stamp: 'lr 10/31/2005 20:06'!
testBeAlignedLeft
	self instance beAlignedLeft.
	self assert: self instance align = #left.
	self deny: self instance isAlignedCenter.
	self assert: self instance isAlignedLeft.
	self deny: self instance isAlignedRight.! !

!PRTableCellTest methodsFor: 'testing-accessing' stamp: 'lr 10/31/2005 20:07'!
testBeAlignedRight
	self instance beAlignedRight.
	self assert: self instance align = #right.
	self deny: self instance isAlignedCenter.
	self deny: self instance isAlignedLeft.
	self assert: self instance isAlignedRight.! !

!PRTableCellTest methodsFor: 'testing-comparing' stamp: 'lr 12/5/2005 20:37'!
testEqualAlign
	self deny: self actualClass new beAlignedRight 
				= self actualClass new beAlignedCenter.
	self deny: self actualClass new beAlignedCenter 
				= self actualClass new beAlignedLeft! !

!PRTableCellTest methodsFor: 'testing-parsing' stamp: 'lr 11/17/2005 16:14'!
testParseAlign1
	| wiki tree |
	wiki := '|{left||center|}right'.
	tree := PRDocument new
		add: (PRTable new
			add: (PRTableRow new
				add: (PRTableCell new
					beAlignedLeft;
					add: (PRText with: 'left');
					yourself);
				add: (PRTableCell new
					beAlignedCenter;
					add: (PRText with: 'center');
					yourself);
				add: (PRTableCell new
					beAlignedRight;
					add: (PRText with: 'right');
					yourself);
				yourself);
			yourself);
		yourself.

	self assertParsing: wiki gives: tree.
	self assertVisiting: tree gives: wiki.! !

!PRTableCellTest methodsFor: 'testing-parsing' stamp: 'lr 11/17/2005 16:15'!
testParseAlign2
	| wiki tree |
	wiki := '|}right|none|{left|none'.
	tree := PRDocument new
		add: (PRTable new
			add: (PRTableRow new
				add: (PRTableCell new
					beAlignedRight;
					add: (PRText with: 'right');
					yourself);
				add: (PRTableCell new
					add: (PRText with: 'none');
					yourself);
				add: (PRTableCell new
					beAlignedLeft;
					add: (PRText with: 'left');
					yourself);
				add: (PRTableCell new
					add: (PRText with: 'none');
					yourself);
				yourself);
			yourself);
		yourself.

	self assertParsing: wiki gives: tree.
	self assertVisiting: tree gives: wiki.! !

!PRTableCellTest methodsFor: 'testing-parsing' stamp: 'lr 11/17/2005 16:15'!
testParseEncoding
	| wiki tree |
	wiki := '|*link*|+embedded+|foo{}'.
	tree := PRDocument new
		add: (PRTable new
			add: (PRTableRow new
				add: (PRTableCell new
					add: (PRInternalLink new
						reference: 'link';
						yourself);
					yourself);
				add: (PRTableCell new
					add: (PRInternalLink new
						reference: 'embedded';
						embedded: true;
						yourself);
					yourself);
				add: (PRTableCell new
					add: (PRText with: 'foo{}');
					yourself);
				yourself);
			yourself);
		yourself.

	self assertParsing: wiki gives: tree.
	self assertVisiting: tree gives: wiki.! !

PRDocumentGroupTest subclass: #PRTableRowTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Tests-Document'!

!PRTableRowTest class methodsFor: 'testing' stamp: 'lr 12/5/2005 20:49'!
isAbstract
	^ false! !

!PRTableRowTest methodsFor: 'private' stamp: 'lr 12/5/2005 20:49'!
actualClass
	^ PRTableRow! !

!PRTableRowTest methodsFor: 'testing-accessing' stamp: 'lr 11/17/2005 16:15'!
testCount
	self instance add: PRTableCell new.
	self assert: self instance columnCount = 1.

	self instance add: PRTableCell new.
	self assert: self instance columnCount = 2.
! !

PRDocumentGroupTest subclass: #PRTableTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Tests-Document'!

!PRTableTest class methodsFor: 'testing' stamp: 'lr 12/5/2005 20:49'!
isAbstract
	^ false! !

!PRTableTest methodsFor: 'private' stamp: 'lr 12/5/2005 20:49'!
actualClass
	^ PRTable! !

!PRTableTest methodsFor: 'testing-accessing' stamp: 'lr 11/17/2005 16:15'!
testCount
	self instance add: (PRTableRow new add: PRTableCell new; yourself).
	self assert: self instance rowCount = 1; assert: self instance columnCount = 1.

	self instance add: (PRTableRow new add: PRTableCell new; add: PRTableCell new; yourself).
	self assert: self instance rowCount = 2; assert: self instance columnCount = 2.

	self instance add: (PRTableRow new add: PRTableCell new; yourself).
	self assert: self instance rowCount = 3; assert: self instance columnCount = 2.
	! !

!PRTableTest methodsFor: 'testing-parsing' stamp: 'lr 11/17/2005 16:16'!
testParseBasic
	| wiki tree |
	wiki := '|cell'.
	tree := PRDocument new
		add: (PRTable new
			add: (PRTableRow new
				add: (PRTableCell new
					add: (PRText with: 'cell');
					yourself);
				yourself);
			yourself);
		yourself.

	self assertParsing: wiki gives: tree.
	self assertVisiting: tree gives: wiki.! !

!PRTableTest methodsFor: 'testing-parsing' stamp: 'lr 11/17/2005 16:16'!
testParseSquare
	| wiki tree |
	wiki := '|a11|a12
|a21|a22'.
	tree := PRDocument new
		add: (PRTable new
			add: (PRTableRow new
				add: (PRTableCell new
					add: (PRText with: 'a11');
					yourself);
				add: (PRTableCell new
					add: (PRText with: 'a12');
					yourself);
				yourself);
			add: (PRTableRow new
				add: (PRTableCell new
					add: (PRText with: 'a21');
					yourself);
				add: (PRTableCell new
					add: (PRText with: 'a22');
					yourself);
				yourself);
			yourself);
		yourself.

	self assertParsing: wiki gives: tree.
	self assertVisiting: tree gives: wiki.! !

!PRTableTest methodsFor: 'testing-parsing' stamp: 'lr 11/17/2005 16:17'!
testParseTriangle
	| wiki tree |
	wiki := '|a11
|a21|a22
|a31|a32|a33'.
	tree := PRDocument new
		add: (PRTable new
			add: (PRTableRow new
				add: (PRTableCell new
					add: (PRText with: 'a11');
					yourself);
				yourself);
			add: (PRTableRow new
				add: (PRTableCell new
					add: (PRText with: 'a21');
					yourself);
				add: (PRTableCell new
					add: (PRText with: 'a22');
					yourself);
				yourself);
			add: (PRTableRow new
				add: (PRTableCell new
					add: (PRText with: 'a31');
					yourself);
				add: (PRTableCell new
					add: (PRText with: 'a32');
					yourself);
				add: (PRTableCell new
					add: (PRText with: 'a33');
					yourself);
				yourself);
			yourself);
		yourself.

	self assertParsing: wiki gives: tree.
	self assertVisiting: tree gives: wiki.! !

!PRDocumentItemTest class methodsFor: 'testing' stamp: 'lr 12/5/2005 20:49'!
isAbstract
	^ true! !

!PRDocumentItemTest methodsFor: 'private' stamp: 'lr 12/5/2005 20:49'!
actualClass
	^ PRDocumentItem! !

!PRDocumentItemTest methodsFor: 'private' stamp: 'lr 12/5/2005 20:46'!
actualInstance
	^ self actualClass new.! !

!PRDocumentItemTest methodsFor: 'utilities' stamp: 'lr 11/21/2005 18:21'!
assertParsing: aString gives: anObject
	self 
		assert: (PRDocumentParser parse: aString) = anObject
		description: aString resumable: true.! !

!PRDocumentItemTest methodsFor: 'utilities' stamp: 'lr 11/21/2005 18:21'!
assertVisiting: anObject gives: aString
	self
		assert: (PRDocumentWriter visit: anObject) = aString
		description: aString resumable: true.! !

!PRDocumentItemTest methodsFor: 'private' stamp: 'lr 11/17/2005 15:43'!
barInstance
	^ PRText with: 'bar'.! !

!PRDocumentItemTest methodsFor: 'private' stamp: 'lr 11/1/2005 07:39'!
exampleSelectors
	"The examples are a collection of selector-paris to be used to retrieve a wiki-string and a wiki-tree to validate parser and writer."

	^ #()! !

!PRDocumentItemTest methodsFor: 'private' stamp: 'lr 10/31/2005 19:37'!
foobarInstances
	^ Array with: self fooInstance with: self barInstance.! !

!PRDocumentItemTest methodsFor: 'private' stamp: 'lr 11/17/2005 15:43'!
fooInstance
	^ PRText with: 'foo'.! !

!PRDocumentItemTest methodsFor: 'accessing' stamp: 'lr 10/31/2005 20:01'!
instance
	^ instance! !

!PRDocumentItemTest methodsFor: 'running' stamp: 'lr 12/5/2005 20:46'!
setUp
	super setUp.
	instance := self actualInstance.! !

!PRDocumentItemTest methodsFor: 'testing-copying' stamp: 'lr 10/31/2005 18:07'!
testCopy
	self assert: self instance = self instance copy.
	self assert: self instance hash = self instance copy hash.

	self deny: self instance == self instance copy.! !

!PRDocumentItemTest methodsFor: 'testing-comparing' stamp: 'lr 12/5/2005 20:46'!
testEqueal
	self assert: self instance = self instance.
	self assert: self instance = self actualInstance.! !

!PRDocumentItemTest methodsFor: 'testing-comparing' stamp: 'lr 11/14/2005 22:10'!
testEquealNil
	self deny: self instance isNil.! !

!PRDocumentItemTest methodsFor: 'testing-comparing' stamp: 'lr 10/31/2005 19:36'!
testEquealOther
	self deny: self instance = self fooInstance.
	self deny: self instance = self barInstance.
! !

!PRDocumentItemTest methodsFor: 'testing-testing' stamp: 'lr 10/20/2005 17:55'!
testHasChildren
	self deny: self instance hasChildren.! !

!PRDocumentItemTest methodsFor: 'testing-comparing' stamp: 'lr 10/20/2005 17:56'!
testHash
	self assert: self instance hash = self instance copy hash.! !

!PRDocumentItemTest methodsFor: 'testing-testing' stamp: 'lr 10/20/2005 17:55'!
testHasOwner
	self deny: self instance hasOwner.! !

!PRDocumentItemTest methodsFor: 'testing-accessing' stamp: 'lr 10/31/2005 18:06'!
testOwner
	self assert: self instance owner isNil.! !

!PRDocumentItemTest methodsFor: 'testing-accessing' stamp: 'lr 10/31/2005 18:06'!
testText
	self assert: self instance text isString.! !

PRDocumentItemTest subclass: #PRHorizontalRuleTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Tests-Document'!

!PRHorizontalRuleTest class methodsFor: 'testing' stamp: 'lr 12/5/2005 20:49'!
isAbstract
	^ false! !

!PRHorizontalRuleTest methodsFor: 'private' stamp: 'lr 12/5/2005 20:49'!
actualClass
	^ PRHorizontalRule! !

!PRHorizontalRuleTest methodsFor: 'testing-parsing' stamp: 'lr 11/17/2005 15:53'!
testParseBasic
	| wiki tree |
	wiki := '_'.
	tree := PRDocument new
		add: PRHorizontalRule new;
		yourself.

	self assertParsing: wiki gives: tree.
	self assertVisiting: tree gives: wiki.! !

!PRHorizontalRuleTest methodsFor: 'testing-parsing' stamp: 'lr 11/17/2005 15:53'!
testParseMultiple
	| wiki tree |
	wiki := '_
_

_'.
	tree := PRDocument new
		add: PRHorizontalRule new;
		add: PRHorizontalRule new;
		add: PRParagraph new;
		add: PRHorizontalRule new;
		yourself.

	self assertParsing: wiki gives: tree.
	self assertVisiting: tree gives: wiki.! !

!PRHorizontalRuleTest methodsFor: 'testing-parsing' stamp: 'lr 11/17/2005 15:53'!
testParseParagraph
	| wiki tree |
	wiki := '_ is parsed as paragraph'.
	tree := PRDocument new
		add: (PRParagraph new
			add: (PRText with: '_ is parsed as paragraph');
			yourself);
		yourself.

	self assertParsing: wiki gives: tree.
	self assertVisiting: tree gives: wiki.! !

!PRHorizontalRuleTest methodsFor: 'testing-parsing' stamp: 'lr 11/17/2005 15:53'!
testParseSpaces
	| wiki tree |
	wiki := '_       '.
	tree := PRDocument new
		add: PRHorizontalRule new;
		yourself.

	self assertParsing: wiki gives: tree.! !

PRDocumentItemTest subclass: #PRTextTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Tests-Document'!

PRTextTest subclass: #PRSmileyTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Tests-Document'!

!PRSmileyTest class methodsFor: 'testing' stamp: 'lr 12/5/2005 20:49'!
isAbstract
	^ false! !

!PRSmileyTest methodsFor: 'private' stamp: 'lr 12/5/2005 20:49'!
actualClass
	^ PRSmiley! !

!PRSmileyTest methodsFor: 'testing-parsing' stamp: 'lr 11/17/2005 16:07'!
testParseSimpleSmiley
	| wiki tree |
	wiki := ':-)'.
	tree := PRDocument new
		add: (PRParagraph new
			add: (PRSmiley with: ':-)');
			yourself);
		yourself.

	self assertParsing: wiki gives: tree.
	self assertVisiting: tree gives: wiki.! !

!PRSmileyTest methodsFor: 'testing-parsing' stamp: 'lr 11/17/2005 16:08'!
testParseSmilieyWithText
	| wiki tree |
	wiki := 'foo :) bar :( zork'.
	tree := PRDocument new
		add: (PRParagraph new
			add: (PRText with: 'foo ');
			add: (PRSmiley with: ':)');
			add: (PRText with: ' bar ');
			add: (PRSmiley with: ':(');
			add: (PRText with: ' zork');
			yourself);
		yourself.

	self assertParsing: wiki gives: tree.
	self assertVisiting: tree gives: wiki.! !

!PRSmileyTest methodsFor: 'testing-parsing' stamp: 'lr 11/17/2005 16:08'!
testParseTwoSmiliey
	| wiki tree |
	wiki := ':)
:('.
	tree := PRDocument new
		add: (PRParagraph new
			add: (PRSmiley with: ':)');
			yourself);
		add: (PRParagraph new
			add: (PRSmiley with: ':(');
			yourself);
		yourself.

	self assertParsing: wiki gives: tree.
	self assertVisiting: tree gives: wiki.! !

!PRSmileyTest methodsFor: 'testing-class' stamp: 'lr 12/5/2005 20:37'!
testSmilies
	self assert: self actualClass smilies notEmpty.
	self actualClass smilies 
		do: [:each | self actualClass smileyAt: each ifAbsent: [self assert: false]]! !

!PRTextTest class methodsFor: 'testing' stamp: 'lr 12/5/2005 20:49'!
isAbstract
	^ false! !

!PRTextTest methodsFor: 'private' stamp: 'lr 12/5/2005 20:49'!
actualClass
	^ PRText! !

!PRTextTest methodsFor: 'testing-comparing' stamp: 'lr 12/5/2005 20:37'!
testEqualText
	self deny: (self actualClass with: 'foo') = (self actualClass with: 'bar')! !

!PRTextTest methodsFor: 'testing-parsing' stamp: 'lr 11/17/2005 16:18'!
testEscapeFirst
	| wiki tree |
	wiki := '\* text
\+ text
\= text
\@ text
\!! text
\| text
\# text
\- text'.
	tree := PRDocument new
		add: (PRParagraph new
			add: (PRText with: '* text');
			yourself);
		add: (PRParagraph new
			add: (PRText with: '+ text');
			yourself);
		add: (PRParagraph new
			add: (PRText with: '= text');
			yourself);
		add: (PRParagraph new
			add: (PRText with: '@ text');
			yourself);
		add: (PRParagraph new
			add: (PRText with: '!! text');
			yourself);
		add: (PRParagraph new
			add: (PRText with: '| text');
			yourself);
		add: (PRParagraph new
			add: (PRText with: '# text');
			yourself);
		add: (PRParagraph new
			add: (PRText with: '- text');
			yourself);
		yourself.

	self assertParsing: wiki gives: tree.
	self assertVisiting: tree gives: wiki.! !

!PRTextTest methodsFor: 'testing-parsing' stamp: 'lr 11/17/2005 16:18'!
testEscapeStrange
	| wiki tree |
	wiki := '< text
> text'.
	tree := PRDocument new
		add: (PRParagraph new
			add: (PRText with: '< text');
			yourself);
		add: (PRParagraph new
			add: (PRText with: '> text');
			yourself);
		yourself.

	self assertParsing: wiki gives: tree.
	self assertVisiting: tree gives: wiki.! !

!PRTextTest methodsFor: 'testing-parsing' stamp: 'lr 11/17/2005 16:18'!
testEscapeText
	| wiki tree |
	wiki := 'Text: \*\+'.
	tree := PRDocument new
		add: (PRParagraph new
			add: (PRText with: 'Text: *+');
			yourself);
		yourself.

	self assertParsing: wiki gives: tree.
	self assertVisiting: tree gives: wiki.! !

!PRTextTest methodsFor: 'testing-parsing' stamp: 'lr 11/17/2005 16:18'!
testEscapeWiki
	| wiki tree |
	wiki := 'Wiki: =, |, !!, #, {, }, |{, ||, |}, [, ] and -'.
	tree := PRDocument new
		add: (PRParagraph new
			add: (PRText with: 'Wiki: =, |, !!, #, {, }, |{, ||, |}, [, ] and -');
			yourself);
		yourself.

	self assertParsing: wiki gives: tree.
	self assertVisiting: tree gives: wiki.! !

!PRTextTest methodsFor: 'testing-parsing' stamp: 'lr 11/17/2005 16:19'!
testParseBasic
	| wiki tree |
	wiki := 'abcdefghijklmnopqrstuvwxyz... ABCDEFGHIJKLMNOPQRSTUVWXYZ... 0123456789...'.
	tree := PRDocument new
		add: (PRParagraph new
			add: (PRText with: 'abcdefghijklmnopqrstuvwxyz... ABCDEFGHIJKLMNOPQRSTUVWXYZ... 0123456789...');
			yourself);
		yourself.

	self assertParsing: wiki gives: tree.
	self assertVisiting: tree gives: wiki.! !

!PRTextTest methodsFor: 'testing-parsing' stamp: 'lr 11/17/2005 16:19'!
testParseHtml
	| wiki tree |
	wiki := '<strong>strong <emph>strong, emph</emph></strong>'.
	tree := PRDocument new
		add: (PRParagraph new
			add: (PRText with: '<strong>strong <emph>strong, emph</emph></strong>');
			yourself);
		yourself.

	self assertParsing: wiki gives: tree.
	self assertVisiting: tree gives: wiki.! !

!PRTextTest methodsFor: 'testing-parsing' stamp: 'lr 11/17/2005 16:19'!
testParseLatex
	| wiki tree |
	wiki := '\begin{foo}[bar]$zork$\end{foo}'.
	tree := PRDocument new
		add: (PRParagraph new
			add: (PRText with: '\begin{foo}[bar]$zork$\end{foo}');
			yourself);
		yourself.

	self assertParsing: wiki gives: tree.
	self assertVisiting: tree gives: wiki.! !

!PRTextTest methodsFor: 'testing-parsing' stamp: 'lr 11/17/2005 16:19'!
testParseSpecial
	| wiki tree |
	wiki := '????????????????????????????????Ƭج????????ĦŦǦɦѦ֦ܦ????ߦƦ???'.
	tree := PRDocument new
		add: (PRParagraph new
			add: (PRText with: '????????????????????????????????Ƭج????????ĦŦǦɦѦ֦ܦ????ߦƦ???');
			yourself);
		yourself.

	self assertParsing: wiki gives: tree.
	self assertVisiting: tree gives: wiki.! !

!PRTextTest methodsFor: 'testing-parsing' stamp: 'lr 11/17/2005 16:19'!
testParseWiki
	| wiki tree |
	wiki := ' !!_#-|=]@:<>\*'.
	tree := PRDocument new
		add: (PRParagraph new
			add: (PRText with: ' !!_#-|=]@:<>*');
			yourself);
		yourself.

	self assertParsing: wiki gives: tree.
	self assertVisiting: tree gives: wiki.! !

!PRTextTest methodsFor: 'testing-accessing' stamp: 'lr 10/20/2005 18:10'!
testText
	self instance text: 'zork'.
	self assert: self instance text = 'zork'.! !

!PRTextTest methodsFor: 'testing-instantiation' stamp: 'lr 12/5/2005 20:37'!
testWith
	instance := self actualClass with: 'zork'.
	self assert: self instance text = 'zork'! !

PRObjectTest subclass: #PRKernelTest
	instanceVariableNames: 'kernel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Tests-Kernel'!

!PRKernelTest class methodsFor: 'testing' stamp: 'lr 12/5/2005 20:49'!
isAbstract
	^ false! !

!PRKernelTest methodsFor: 'private' stamp: 'lr 12/5/2005 20:49'!
actualClass
	^ PRKernel! !

!PRKernelTest methodsFor: 'accessing' stamp: 'lr 10/26/2005 07:34'!
instance
	^ self kernel.! !

!PRKernelTest methodsFor: 'accessing' stamp: 'lr 10/26/2005 07:34'!
kernel
	^ kernel ifNil: [ kernel := self kernelInstance ].! !

!PRKernelTest methodsFor: 'testing' stamp: 'lr 10/26/2005 07:29'!
testInitialState
	self deny: self kernel mutex isNil.
	self deny: self kernel name isNil.
	self deny: self kernel persistency isNil.
	self deny: self kernel root isNil.
	! !

!PRKernelTest methodsFor: 'testing-mutex' stamp: 'lr 10/26/2005 07:30'!
testMutexError
	"An error inside the critical section should properly unlock it for others to enter."

	| marker |
	self 
		should: [ self kernel critical: [ Error signal ] ] 
		raise: Error.

	self kernel critical: [ marker := 1 ].
	self assert: marker = 1.! !

!PRKernelTest methodsFor: 'testing-mutex' stamp: 'lr 10/26/2005 07:30'!
testMutexForked
	"Two different processed are not allowed to be inside the critical section at once."

	| in1 sem1 in2 sem2  |
	in1 := false. 
	in2 := false.
	
	sem1 := Semaphore new.
	sem2 := Semaphore new.

	[ self kernel critical: [ in1 := true. sem1 signal. sem2 wait ] ] fork.
	[ self kernel critical: [ in2 := true. sem1 signal. sem2 wait ] ] fork.

	sem1 wait.
	self deny: in1 = in2.
	sem2 signal.

	sem1 wait.
	self assert: in1 = in2.
	sem2 signal.! !

!PRKernelTest methodsFor: 'testing-mutex' stamp: 'lr 10/26/2005 07:30'!
testMutexNested
	"Critical sections should be nestable to any level within one process."

	| marker |	
	self kernel critical: [ 
		self kernel critical: [ 
			marker := 1 ] ].
	self assert: marker = 1.

	self kernel critical: [ 
		self kernel critical: [ 
			self kernel critical: [ 
				marker := 2 ] ] ].
	self assert: marker = 2.! !

!PRKernelTest methodsFor: 'testing-mutex' stamp: 'lr 10/26/2005 07:30'!
testMutexSimple
	| marker |
	self kernel critical: [ marker := 1 ].
	self assert: marker = 1.! !

!PRKernelTest methodsFor: 'testing-accessing' stamp: 'lr 10/26/2005 07:29'!
testName
	self kernel name: 'kernel'.
	self assert: self kernel name = 'kernel'.! !

!PRKernelTest methodsFor: 'testing-accessing' stamp: 'lr 11/17/2005 15:58'!
testPersistency
	| persistency |
	self kernel persistency: (persistency := PRNullPersistency new).
	self assert: self kernel persistency = persistency.
	self assert: self kernel = persistency kernel.! !

!PRKernelTest methodsFor: 'testing-accessing' stamp: 'lr 11/17/2005 16:00'!
testRoot
	| structure |
	self kernel root: (structure := PRPage new).
	self assert: self kernel root = structure.! !

!PRObjectTest class methodsFor: 'building' stamp: 'lr 12/5/2005 20:58'!
buildTestClassFor: aClass 
	" self buildTestClassFor: PRObject "

	| thisName thisClass thisCategory parentClass |
	thisName := (aClass name , 'Test') asSymbol.
	(thisName beginsWith: 'PR') 
		ifFalse: [ ^ self ].
	thisClass := MACompatibility classNamed: thisName.
	thisCategory := 'Pier-Tests-' , (aClass category copyAfterLast: $-).
	parentClass := self = thisClass 
		ifTrue: [ self superclass ]
		ifFalse: [ Smalltalk classNamed: (aClass superclass name , 'Test') asSymbol ].
	thisClass := parentClass 
		subclass: thisName
		instanceVariableNames: (thisClass isNil 
			ifFalse: [ thisClass instanceVariablesString ]
			ifTrue: [ String new ])
			classVariableNames: ''
			poolDictionaries: ''
			category: thisCategory.
	thisClass 
		compile: 'actualClass
	^ ' , aClass name 
		classified: #private.
	thisClass class 
		compile: 'isAbstract
	^ ' , aClass isAbstract asString
		classified: #testing.
	aClass subclassesDo: [ :each | self buildTestClassFor: each ].! !

!PRObjectTest class methodsFor: 'testing' stamp: 'lr 12/5/2005 20:49'!
isAbstract
	^ true! !

!PRObjectTest class methodsFor: 'testing' stamp: 'lr 10/20/2005 15:01'!
shouldInheritSelectors
	^ true! !

!PRObjectTest methodsFor: 'private' stamp: 'lr 12/5/2005 20:49'!
actualClass
	^ PRObject! !

!PRObjectTest methodsFor: 'private' stamp: 'lr 12/5/2005 09:37'!
contextInstance
	^ PRContext kernel: self kernelInstance.! !

!PRObjectTest methodsFor: 'accessing' stamp: 'lr 11/3/2005 07:04'!
instance
	self subclassResponsibility.! !

!PRObjectTest methodsFor: 'private' stamp: 'lr 12/5/2005 11:28'!
kernelInstance
	^ PRKernel new
		name: 'test';
		root: self rootInstance;
		persistency: self persistencyInstance;
		yourself.! !

!PRObjectTest methodsFor: 'private' stamp: 'lr 11/17/2005 16:03'!
persistencyInstance
	^ PRNullPersistency new.! !

!PRObjectTest methodsFor: 'private' stamp: 'lr 12/5/2005 11:36'!
rootInstance
	^ PRPage new
		title: 'root';
		addChild: (PRPage new
			title: 'folder';
			addChild: (PRPage new
				title: 'child';
				yourself);
			addChild: self structureInstance;
			yourself);
		yourself.! !

!PRObjectTest methodsFor: 'private' stamp: 'lr 12/5/2005 11:30'!
structureInstance
	^ PRPage new
		title: 'structure';
		yourself.! !

!PRObjectTest methodsFor: 'testing-copying' stamp: 'lr 10/20/2005 12:05'!
testCopyProperties
	self assert: self instance properties = self instance copy properties.
	self deny: self instance properties == self instance copy properties.! !

!PRObjectTest methodsFor: 'testing-properties' stamp: 'lr 10/20/2005 12:05'!
testProperties
	self assert: self instance properties notNil.
	self instance instVarNamed: 'properties' put: nil.
	
	self instance propertyAt: #foo put: #bar.
	self instance instVarNamed: 'properties' put: nil.

	self instance propertyAt: #foo ifAbsent: [ nil ].
	self instance instVarNamed: 'properties' put: nil.

	self instance propertyAt: #foo ifAbsentPut: [ #bar ].
	self instance instVarNamed: 'properties' put: nil.
	
	self instance hasProperty: #foo.
	self instance instVarNamed: 'properties' put: nil.! !

!PRObjectTest methodsFor: 'testing-properties' stamp: 'lr 10/24/2005 23:26'!
testPropertiesAt
	self assert: (self instance propertyAt: #foo put: 'bar') = 'bar'.
	self assert: (self instance propertyAt: #foo) = 'bar'.
	self should: [ self instance propertyAt: #bar ] raise: Error.! !

!PRObjectTest methodsFor: 'testing-properties' stamp: 'lr 10/20/2005 12:05'!
testPropertiesAtIfAbsent
	self assert: (self instance propertyAt: #foo put: 'bar') = 'bar'.
	self assert: (self instance propertyAt: #foo ifAbsent: [ 'baz' ]) = 'bar'.
	self assert: (self instance propertyAt: #bar ifAbsent: [ 'baz' ]) = 'baz'.! !

!PRObjectTest methodsFor: 'testing-properties' stamp: 'lr 10/20/2005 12:05'!
testPropertiesAtIfAbsentPut
	self assert: (self instance propertyAt: #foo put: 'bar') = 'bar'.
	self assert: (self instance propertyAt: #foo ifAbsentPut: [ 'baz' ]) = 'bar'.
	self assert: (self instance propertyAt: #foo) = 'bar'.
	
	self assert: (self instance propertyAt: #bar ifAbsentPut: [ 'baz' ]) = 'baz'.
	self assert: (self instance propertyAt: #bar) = 'baz'.! !

!PRObjectTest methodsFor: 'testing-properties' stamp: 'lr 10/20/2005 12:05'!
testPropertiesAtPut
	self instance propertyAt: #foo put: 'bar'.
	self assert: (self instance propertyAt: #foo) = 'bar'.
	
	self instance propertyAt: #foo put: 'baz'.
	self assert: (self instance propertyAt: #foo) = 'baz'.! !

!PRObjectTest methodsFor: 'testing-properties' stamp: 'lr 10/20/2005 12:05'!
testPropertiesHas
	self deny: (self instance hasProperty: #foo).
	self instance propertyAt: #foo put: 'bar'.
	self assert: (self instance hasProperty: #foo).
	self deny: (self instance hasProperty: #bar).! !

!PRObjectTest methodsFor: 'testing' stamp: 'lr 12/5/2005 21:04'!
testSanity
	"If this test case fails, there is something wrong with the setup of the test-case."

	self 
		assert: self actualClass isAbstract not
		description: 'Unable to test abstract class.'.
	self
		assert: self instance class = self actualClass
		description: 'Invalid test instance.'! !

TestCase subclass: #PRQueryTests
	instanceVariableNames: 'root folder page file query'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Tests-Utilities'!

!PRQueryTests methodsFor: 'utilities' stamp: 'lr 12/16/2005 12:13'!
assertQuery: aString gives: aCollection
	| result |
	result := PRQueryVisitor start: root string: aString.
	self
		assert: aCollection asSet = result
		description: aCollection asString
		resumable: true.! !

!PRQueryTests methodsFor: 'running' stamp: 'lr 12/5/2005 21:59'!
setUp
	root := PRPage new
		title: 'Root';
		contents: '!!11';
		addChild: (folder := PRPage new
			title: 'Folder';
			contents: '|*http://lukas-renggli.ch*';
			addChild: (page := PRPage new
				title: 'Page';
				contents: '!!!!22';
				yourself);
			addChild: (file := PRFile new
				title: 'File';
				yourself);
			yourself);
		yourself.! !

!PRQueryTests methodsFor: 'testing-structures' stamp: 'lr 12/5/2005 22:04'!
testMatch
	self assertQuery: '''22''' gives: (Array with: page).! !

!PRQueryTests methodsFor: 'testing-structures' stamp: 'lr 4/17/2005 16:23'!
testTitleEqualTo
	self assertQuery: 'title = ''Folder'' OR title = ''File''' gives: (Array with: folder with: file).! !

!PRQueryTests methodsFor: 'testing-structures' stamp: 'lr 4/17/2005 18:21'!
testTitleMatch
	self assertQuery: 'title matches: ''l''' gives: (Array with: folder with: file).! !

!PRQueryTests methodsFor: 'testing-documents' stamp: 'lr 4/17/2005 18:18'!
testUrl
	self assertQuery: 'url matches: ''lukas''' gives: (Array with: folder).
	self assertQuery: 'url matches: ''*lukas*''' gives: (Array with: folder).! !

TestCase subclass: #PRUtilitiesTests
	instanceVariableNames: 'object foo'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Tests-Utilities'!

!PRUtilitiesTests methodsFor: 'accessing' stamp: 'lr 3/7/2005 12:15'!
foo
	^foo! !

!PRUtilitiesTests methodsFor: 'accessing' stamp: 'lr 3/7/2005 12:15'!
foo: anObject
	foo := anObject! !

!PRUtilitiesTests methodsFor: 'testing-indexed-collection' stamp: 'lr 11/17/2005 16:19'!
testIndexedAdd
	object := PRIndexedCollection 
		on: OrderedCollection new
		selectors: #( size last reverse ).

	self assert: (object add: 'ab') = (object at: 1).
	
	self assert: (object index: #size at: 2) = (object at: 1).
	self assert: (object index: #last at: $b) = (object at: 1).
	self assert: (object index: #reverse at: 'ba') = (object at: 1).! !

!PRUtilitiesTests methodsFor: 'testing-indexed-collection' stamp: 'lr 11/17/2005 16:19'!
testIndexedAt
	object := PRIndexedCollection 
		on: #( 'a' 'ab' 'abc' ) 
		selectors: #( size last reverse ).

	self assert: (object at: 1) == (object index: #size at: 1).
	self assert: (object at: 2) == (object index: #size at: 2).
	self assert: (object at: 3) == (object index: #size at: 3).
	
	self assert: (object at: 1) == (object index: #last at: $a).
	self assert: (object at: 2) == (object index: #last at: $b).
	self assert: (object at: 3) == (object index: #last at: $c).

	self assert: (object at: 1) == (object index: #reverse at: 'a').
	self assert: (object at: 2) == (object index: #reverse at: 'ba').
	self assert: (object at: 3) == (object index: #reverse at: 'cba').
	! !

!PRUtilitiesTests methodsFor: 'testing-indexed-collection' stamp: 'lr 11/17/2005 16:19'!
testIndexedRemove
	object := PRIndexedCollection 
		on: #( 'ab' ) asOrderedCollection
		selectors: #( size last reverse ).

	self assert: (object remove: 'ab') = 'ab'.
		
	self assert: (object index: #size at: 2 ifAbsent: nil) isNil.
	self assert: (object index: #last at: $b ifAbsent: nil) isNil.
	self assert: (object index: #reverse at: 'ba' ifAbsent: nil) isNil.! !

!PRUtilitiesTests methodsFor: 'testing-indexed-collection' stamp: 'lr 11/17/2005 16:19'!
testIndexedSelect
	object := PRIndexedCollection 
		on: #( 'a' 'ab' 'abc' 'abcd' ) asSet
		selectors: #( size reverse ).
	object := object select: [ :each |
		each size even ].
	
	self assert: (object size = 2).
	self assert: (object includes: 'ab').
	self assert: (object includes: 'abcd').! !

!PRUtilitiesTests methodsFor: 'testing-indexed-collection' stamp: 'lr 11/17/2005 16:19'!
testIndexedSize
	object := PRIndexedCollection 
		on: #( 'a' 'ab' ) 
		selectors: #( size last reverse ).
	
	self assert: object size = 2.
	self assert: object collection size = 2.
	
	self assert: object selectors size = 3.
	self assert: object indexes size = 3.! !

!PRUtilitiesTests methodsFor: 'testing-macro-expander' stamp: 'lr 11/17/2005 15:37'!
testMacroInitialized
	| expander |
	expander := PRMacroExpander new.
	
	self assert: expander character = $%.
	self assert: expander default notNil.
	self assert: expander table isEmpty.! !

!PRUtilitiesTests methodsFor: 'testing-macro-expander' stamp: 'lr 11/17/2005 15:37'!
testMacroValue
	| expander |
	expander := PRMacroExpander new.
	expander table 	
		at: $1 put: [ '!!1' ]; 
		at: $2 put: [ '!!2' ].
	
	self assert: (expander value: '') = ''.
	self assert: (expander value: 'xyz') = 'xyz'.
	
	self assert: (expander value: '%1') = '!!1'.
	self assert: (expander value: '%2') = '!!2'.

	self assert: (expander value: '%1xy') = '!!1xy'.
	self assert: (expander value: 'x%1y') = 'x!!1y'.
	self assert: (expander value: 'xy%1') = 'xy!!1'.
	
	self assert: (expander value: '%2xy') = '!!2xy'.
	self assert: (expander value: 'x%2y') = 'x!!2y'.
	self assert: (expander value: 'xy%2') = 'xy!!2'.
	
	self assert: (expander value: '%1%2') = '!!1!!2'.
	self assert: (expander value: 'x%1%2') = 'x!!1!!2'.
	self assert: (expander value: 'x%1y%2') = 'x!!1y!!2'.
	self assert: (expander value: 'x%1y%2z') = 'x!!1y!!2z'.
	
	self assert: (expander value: '%%') = '%'.
	self assert: (expander value: '%3') = '%3'.! !

!PRUtilitiesTests methodsFor: 'testing-macro-expander' stamp: 'lr 11/17/2005 15:37'!
testMacroValueValue
	| expander |
	expander := PRMacroExpander new.
	expander table 
		at: $1 put: [ :char | '!!' , char asString ]; 
		at: $2 put: [ :char | '!!' , char asString ].
	
	self assert: (expander value: '') = ''.
	self assert: (expander value: 'xyz') = 'xyz'.

	self assert: (expander value: '%1') = '!!1'.
	self assert: (expander value: '%2') = '!!2'.

	self assert: (expander value: '%1xy') = '!!1xy'.
	self assert: (expander value: 'x%1y') = 'x!!1y'.
	self assert: (expander value: 'xy%1') = 'xy!!1'.
	
	self assert: (expander value: '%2xy') = '!!2xy'.
	self assert: (expander value: 'x%2y') = 'x!!2y'.
	self assert: (expander value: 'xy%2') = 'xy!!2'.
	
	self assert: (expander value: '%1%2') = '!!1!!2'.
	self assert: (expander value: 'x%1%2') = 'x!!1!!2'.
	self assert: (expander value: 'x%1y%2') = 'x!!1y!!2'.
	self assert: (expander value: 'x%1y%2z') = 'x!!1y!!2z'.
	
	self assert: (expander value: '%%') = '%'.
	self assert: (expander value: '%3') = '%3'.! !

!PRUtilitiesTests methodsFor: 'testing-macro-expander' stamp: 'lr 11/17/2005 15:37'!
testMacroValueValueValue
	| expander |
	expander := PRMacroExpander new.
	expander table 
		at: $1 put: [ :char :arg | arg , char asString ]; 
		at: $2 put: [ :char :arg | arg , char asString ].
	
	self assert: (expander value: '') = ''.
	self assert: (expander value: 'xyz') = 'xyz'.
	
	self assert: (expander value: '%1' value: '!!') = '!!1'.
	self assert: (expander value: '%2' value: '!!') = '!!2'.

	self assert: (expander value: '%1xy' value: '!!') = '!!1xy'.
	self assert: (expander value: 'x%1y' value: '!!') = 'x!!1y'.
	self assert: (expander value: 'xy%1' value: '!!') = 'xy!!1'.
	
	self assert: (expander value: '%2xy' value: '!!') = '!!2xy'.
	self assert: (expander value: 'x%2y' value: '!!') = 'x!!2y'.
	self assert: (expander value: 'xy%2' value: '!!') = 'xy!!2'.
	
	self assert: (expander value: '%1%2' value: '!!') = '!!1!!2'.
	self assert: (expander value: 'x%1%2' value: '!!') = 'x!!1!!2'.
	self assert: (expander value: 'x%1y%2' value: '!!') = 'x!!1y!!2'.
	self assert: (expander value: 'x%1y%2z' value: '!!') = 'x!!1y!!2z'.! !

TestCase subclass: #PRVisitorTests
	instanceVariableNames: 'visitor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Tests-Utilities'!

!PRVisitorTests methodsFor: 'running' stamp: 'lr 11/17/2005 15:36'!
setUp
	visitor := PRVisitor new.! !

!PRVisitorTests methodsFor: 'testing-escaper' stamp: 'lr 11/3/2005 07:49'!
testEnsureEscape
	| tag |
	self assert: (visitor withEscaper: [
		[ true ]
			ensure: [ tag := 1 ] ]).
	self assert: tag = 1.
	
	self assert: (visitor withEscaper: [
		[ visitor escape: true ]
			ensure: [ tag := 2 ] ]).
	self assert: tag = 2.! !

!PRVisitorTests methodsFor: 'testing-escaper' stamp: 'lr 10/21/2005 11:27'!
testEscaper
	self assert: (visitor withEscaper: [ true ]).
	self deny: (visitor withEscaper: [ false ]).

	self assert: (visitor withEscaper: [ visitor escape: true. false ]).
	self deny: (visitor withEscaper: [ visitor escape: false. true ]).! !

!PRVisitorTests methodsFor: 'testing-escaper' stamp: 'lr 4/5/2005 07:38'!
testHasEscaper
	self deny: visitor hasEscaper.
	self assert: (visitor withEscaper: [ visitor hasEscaper ]).! !
